/* A Bison parser, made by GNU Bison 1.875d.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Using locations.  */
#define YYLSP_NEEDED 0






/* Copy the first part of user declarations.  */
#line 26 "lscp.y"


#include "lscpparser.h"
#include "lscpserver.h"
#include "lscpevent.h"

// to save us typing work in the rules action definitions
#define LSCPSERVER ((yyparse_param_t*) yyparse_param)->pServer

// clears input buffer
void restart(yyparse_param_t* pparam, int& yychar);
#define RESTART restart((yyparse_param_t*) YYPARSE_PARAM, yychar)

// we provide our own version of yyerror() so we don't have to link against the yacc library
void yyerror(const char* s);

static char buf[1024]; // input buffer to feed the parser with new characters
static int bytes = 0;  // current number of characters in the input buffer
static int ptr   = 0;  // current position in the input buffer

// external reference to the function which actually reads from the socket
extern int GetLSCPCommand( void *buf, int max_size);

// custom scanner function which reads from the socket
int yylex(YYSTYPE* yylval) {
    // check if we have to read new characters
    if (ptr >= bytes) {
        bytes = GetLSCPCommand(buf, 1023);
        ptr   = 0;
        if (bytes < 0) {
            bytes = 0;
            return 0;
        }
    }
    return (int) buf[ptr++];
}



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 121 "y.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  40
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   3997

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  227
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  91
/* YYNRULES -- Number of rules. */
#define YYNRULES  417
/* YYNRULES -- Number of states. */
#define YYNSTATES  1144

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   257

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     225,     2,     2,   226,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,   224,    70,   223,     3,    71,    72,    73,   222,
      74,    75,    76,     6,    77,     7,     5,    78,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    79,    80,
      81,     4,    82,    83,    84,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    85,    86,    87,    88,    89,     2,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    90,    91,    92,    93,     2,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,     1,     2
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     6,    10,    11,    13,    15,    17,    19,
      22,    25,    28,    31,    35,    39,    43,    47,    51,    55,
      61,    65,    69,    73,    77,    83,    85,    87,    89,    91,
      93,    95,    97,    99,   101,   103,   105,   107,   109,   111,
     113,   115,   121,   129,   139,   141,   147,   155,   165,   167,
     169,   175,   181,   189,   199,   207,   217,   219,   225,   233,
     239,   245,   251,   259,   269,   277,   287,   291,   295,   301,
     305,   311,   315,   319,   323,   327,   331,   337,   345,   351,
     361,   367,   373,   379,   385,   391,   395,   401,   403,   405,
     407,   409,   411,   417,   425,   429,   431,   433,   435,   437,
     439,   441,   443,   445,   447,   449,   451,   453,   455,   457,
     459,   461,   463,   465,   467,   469,   472,   476,   481,   486,
     488,   491,   493,   495,   497,   499,   501,   503,   505,   507,
     509,   511,   513,   516,   519,   522,   525,   528,   531,   534,
     537,   540,   542,   544,   546,   548,   550,   552,   554,   556,
     558,   560,   562,   564,   566,   568,   570,   572,   574,   576,
     578,   580,   582,   584,   586,   588,   590,   592,   594,   596,
     598,   600,   602,   604,   606,   608,   610,   612,   614,   616,
     618,   620,   622,   624,   626,   628,   630,   632,   634,   636,
     638,   640,   642,   644,   646,   648,   650,   652,   654,   656,
     658,   660,   662,   664,   666,   668,   670,   672,   674,   676,
     678,   680,   682,   684,   686,   688,   690,   692,   694,   696,
     698,   700,   702,   704,   706,   708,   710,   712,   714,   716,
     718,   720,   722,   724,   726,   728,   730,   732,   734,   736,
     738,   740,   742,   744,   746,   748,   750,   752,   754,   756,
     758,   760,   762,   764,   766,   768,   770,   772,   774,   776,
     778,   780,   782,   784,   786,   788,   790,   792,   794,   796,
     798,   800,   802,   804,   806,   808,   810,   812,   814,   816,
     818,   820,   822,   824,   826,   828,   830,   832,   834,   836,
     838,   840,   842,   844,   846,   848,   850,   852,   854,   856,
     858,   860,   862,   864,   866,   868,   870,   872,   874,   876,
     878,   880,   882,   884,   886,   888,   890,   892,   894,   896,
     898,   900,   902,   904,   906,   908,   910,   912,   914,   916,
     918,   920,   922,   924,   926,   928,   930,   932,   934,   936,
     938,   940,   942,   944,   946,   948,   950,   952,   954,   956,
     958,   960,   962,   964,   966,   968,   970,   972,   974,   976,
     978,   980,   982,   985,   988,   992,   996,   998,  1000,  1002,
    1006,  1010,  1017,  1025,  1030,  1035,  1039,  1049,  1056,  1060,
    1070,  1082,  1089,  1097,  1115,  1146,  1155,  1160,  1172,  1185,
    1197,  1208,  1215,  1245,  1266,  1286,  1316,  1336,  1367,  1388,
    1406,  1435,  1463,  1489,  1508,  1526,  1554,  1572,  1588,  1607,
    1623,  1634,  1641,  1647,  1658,  1664,  1678,  1683
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short int yyrhs[] =
{
     228,     0,    -1,   229,   267,    -1,   229,   268,   267,    -1,
      -1,   230,    -1,   231,    -1,     1,    -1,     3,    -1,   230,
       3,    -1,   230,   266,    -1,   230,   262,    -1,   230,   258,
      -1,   269,   266,   282,    -1,   270,   266,   234,    -1,   271,
     266,   236,    -1,   272,   266,   237,    -1,   273,   266,   242,
      -1,   274,   266,   238,    -1,   277,   266,   282,   266,   252,
      -1,   278,   266,   235,    -1,   279,   266,   232,    -1,   280,
     266,   233,    -1,   281,   266,   264,    -1,   314,   266,   282,
     266,   252,    -1,   314,    -1,   317,    -1,   285,    -1,   289,
      -1,   288,    -1,   287,    -1,   286,    -1,   315,    -1,   285,
      -1,   289,    -1,   288,    -1,   287,    -1,   286,    -1,   315,
      -1,   283,    -1,   300,    -1,   306,   266,   286,   266,   258,
      -1,   305,   266,   286,   266,   258,   266,   258,    -1,   305,
     266,   286,   266,   258,   266,   258,   266,   240,    -1,   284,
      -1,   296,   266,   286,   266,   258,    -1,   295,   266,   286,
     266,   258,   266,   258,    -1,   295,   266,   286,   266,   258,
     266,   258,   266,   240,    -1,   293,    -1,   303,    -1,   294,
     266,   286,   266,   262,    -1,   304,   266,   286,   266,   262,
      -1,   307,   266,   286,   266,   262,   266,   262,    -1,   302,
     266,   286,   266,   262,   266,   262,   266,   258,    -1,   298,
     266,   286,   266,   262,   266,   262,    -1,   297,   266,   286,
     266,   262,   266,   262,   266,   258,    -1,   285,    -1,   282,
     266,   286,   266,   252,    -1,   282,   266,   287,   266,   241,
     266,   252,    -1,   282,   266,   288,   266,   252,    -1,   282,
     266,   289,   266,   252,    -1,   291,   266,   286,   266,   254,
      -1,   292,   266,   262,   266,   258,     4,   256,    -1,   297,
     266,   262,   266,   262,   266,   258,     4,   256,    -1,   301,
     266,   262,   266,   258,     4,   256,    -1,   302,   266,   262,
     266,   262,   266,   258,     4,   256,    -1,   282,   266,   239,
      -1,   316,   266,   257,    -1,   294,   266,   258,   266,   240,
      -1,   294,   266,   258,    -1,   304,   266,   258,   266,   240,
      -1,   304,   266,   258,    -1,   294,   266,   262,    -1,   304,
     266,   262,    -1,   290,   266,   243,    -1,   291,   266,   244,
      -1,   294,   266,   252,   266,   245,    -1,   298,   266,   252,
     266,   246,   266,   246,    -1,   299,   266,   252,   266,   247,
      -1,   310,   266,   252,   266,   245,   266,   248,   266,   249,
      -1,   304,   266,   252,   266,   245,    -1,   307,   266,   252,
     266,   248,    -1,   308,   266,   252,   266,   249,    -1,   309,
     266,   252,   266,   250,    -1,   311,   266,   252,   266,   251,
      -1,   258,     4,   256,    -1,   240,   266,   258,     4,   256,
      -1,   312,    -1,   313,    -1,   293,    -1,   303,    -1,   285,
      -1,   255,   266,   253,   266,   252,    -1,   276,   266,   255,
     266,   253,   266,   252,    -1,   254,   266,   252,    -1,   262,
      -1,   262,    -1,   258,    -1,   262,    -1,   262,    -1,   275,
      -1,   258,    -1,   259,    -1,   262,    -1,   262,    -1,   262,
      -1,   258,    -1,   265,    -1,   258,    -1,   265,    -1,   262,
      -1,   259,    -1,   262,    -1,   258,    -1,   263,    -1,   258,
     263,    -1,   260,     5,   260,    -1,     6,   260,     5,   260,
      -1,     7,   260,     5,   260,    -1,   261,    -1,   260,   261,
      -1,     8,    -1,     9,    -1,    10,    -1,    11,    -1,    12,
      -1,    13,    -1,    14,    -1,    15,    -1,    16,    -1,    17,
      -1,   261,    -1,     9,   260,    -1,    10,   260,    -1,    11,
     260,    -1,    12,   260,    -1,    13,   260,    -1,    14,   260,
      -1,    15,   260,    -1,    16,   260,    -1,    17,   260,    -1,
      18,    -1,    19,    -1,    20,    -1,    21,    -1,    22,    -1,
      23,    -1,    24,    -1,    25,    -1,    26,    -1,    27,    -1,
      28,    -1,    29,    -1,    30,    -1,    31,    -1,    32,    -1,
      33,    -1,    34,    -1,    35,    -1,    36,    -1,    37,    -1,
      38,    -1,    39,    -1,    40,    -1,    41,    -1,    42,    -1,
      43,    -1,    44,    -1,    45,    -1,    46,    -1,    47,    -1,
      48,    -1,    49,    -1,    50,    -1,    51,    -1,    52,    -1,
      53,    -1,    54,    -1,    55,    -1,    56,    -1,    57,    -1,
      58,    -1,    59,    -1,    60,    -1,    61,    -1,    62,    -1,
      63,    -1,    64,    -1,    65,    -1,    66,    -1,    67,    -1,
      68,    -1,    69,    -1,     8,    -1,     9,    -1,    10,    -1,
      11,    -1,    12,    -1,    13,    -1,    14,    -1,    15,    -1,
      16,    -1,    17,    -1,    70,    -1,     3,    -1,    71,    -1,
      72,    -1,    73,    -1,    74,    -1,    75,    -1,    76,    -1,
       6,    -1,     7,    -1,     5,    -1,    77,    -1,    78,    -1,
      79,    -1,    80,    -1,    81,    -1,     4,    -1,    82,    -1,
      83,    -1,    84,    -1,    85,    -1,    86,    -1,    87,    -1,
      88,    -1,    89,    -1,    90,    -1,    91,    -1,    92,    -1,
      93,    -1,    94,    -1,    95,    -1,    96,    -1,    97,    -1,
      98,    -1,    99,    -1,   100,    -1,   101,    -1,   102,    -1,
     103,    -1,   104,    -1,   105,    -1,   106,    -1,   107,    -1,
     108,    -1,   109,    -1,   110,    -1,   111,    -1,   112,    -1,
     113,    -1,   114,    -1,   115,    -1,   116,    -1,   117,    -1,
     118,    -1,   119,    -1,   120,    -1,   121,    -1,   122,    -1,
     123,    -1,   124,    -1,   125,    -1,   126,    -1,   127,    -1,
     128,    -1,   129,    -1,   130,    -1,   131,    -1,   132,    -1,
     133,    -1,   134,    -1,   135,    -1,   136,    -1,   137,    -1,
     138,    -1,   139,    -1,   140,    -1,   141,    -1,   142,    -1,
     143,    -1,   144,    -1,   145,    -1,   146,    -1,   147,    -1,
     148,    -1,   149,    -1,   150,    -1,   151,    -1,   152,    -1,
     153,    -1,   154,    -1,   155,    -1,   156,    -1,   157,    -1,
     158,    -1,   159,    -1,   160,    -1,   161,    -1,   162,    -1,
     163,    -1,   164,    -1,   165,    -1,   166,    -1,   167,    -1,
     168,    -1,   169,    -1,   170,    -1,   171,    -1,   172,    -1,
     173,    -1,   174,    -1,   175,    -1,   176,    -1,   177,    -1,
     178,    -1,   179,    -1,   180,    -1,   181,    -1,   182,    -1,
     183,    -1,   184,    -1,   185,    -1,   186,    -1,   187,    -1,
     188,    -1,   189,    -1,   190,    -1,   191,    -1,   192,    -1,
     193,    -1,   194,    -1,   195,    -1,   196,    -1,   197,    -1,
     198,    -1,   199,    -1,   200,    -1,   201,    -1,   202,    -1,
     203,    -1,   204,    -1,   205,    -1,   206,    -1,   207,    -1,
     208,    -1,   209,    -1,   210,    -1,   211,    -1,   212,    -1,
     213,    -1,   214,    -1,   215,    -1,   216,    -1,   217,    -1,
     218,    -1,   219,    -1,   220,    -1,   221,    -1,   266,    -1,
     258,    -1,   264,   266,    -1,   264,   258,    -1,   222,   264,
     222,    -1,   223,   264,   223,    -1,   224,    -1,   225,    -1,
     226,    -1,    18,    21,    21,    -1,    24,    22,    37,    -1,
      20,    35,    22,    18,    37,    22,    -1,    21,    22,    36,
      37,    35,    32,    42,    -1,    29,    26,    36,    37,    -1,
      29,    32,    18,    21,    -1,    18,    29,    29,    -1,    31,
      32,    31,    89,    30,    32,    21,    18,    29,    -1,    35,
      22,    30,    32,    39,    22,    -1,    36,    22,    37,    -1,
      36,    38,    19,    36,    20,    35,    26,    19,    22,    -1,
      38,    31,    36,    38,    19,    36,    20,    35,    26,    19,
      22,    -1,    36,    22,    29,    22,    20,    37,    -1,    20,
      25,    18,    31,    31,    22,    29,    -1,    18,    39,    18,
      26,    29,    18,    19,    29,    22,    89,    22,    31,    24,
      26,    31,    22,    36,    -1,    18,    39,    18,    26,    29,
      18,    19,    29,    22,    89,    18,    38,    21,    26,    32,
      89,    32,    38,    37,    33,    38,    37,    89,    21,    35,
      26,    39,    22,    35,    36,    -1,    20,    25,    18,    31,
      31,    22,    29,    36,    -1,    26,    31,    23,    32,    -1,
      19,    38,    23,    23,    22,    35,    89,    23,    26,    29,
      29,    -1,    36,    37,    35,    22,    18,    30,    89,    20,
      32,    38,    31,    37,    -1,    39,    32,    26,    20,    22,
      89,    20,    32,    38,    31,    37,    -1,    26,    31,    36,
      37,    35,    38,    30,    22,    31,    37,    -1,    22,    31,
      24,    26,    31,    22,    -1,    18,    38,    21,    26,    32,
      89,    32,    38,    37,    33,    38,    37,    89,    21,    22,
      39,    26,    20,    22,    89,    33,    18,    35,    18,    30,
      22,    37,    22,    35,    -1,    18,    38,    21,    26,    32,
      89,    32,    38,    37,    33,    38,    37,    89,    21,    22,
      39,    26,    20,    22,    36,    -1,    18,    38,    21,    26,
      32,    89,    32,    38,    37,    33,    38,    37,    89,    21,
      22,    39,    26,    20,    22,    -1,    18,    38,    21,    26,
      32,    89,    32,    38,    37,    33,    38,    37,    89,    21,
      35,    26,    39,    22,    35,    89,    33,    18,    35,    18,
      30,    22,    37,    22,    35,    -1,    18,    38,    21,    26,
      32,    89,    32,    38,    37,    33,    38,    37,    89,    21,
      35,    26,    39,    22,    35,    -1,    18,    38,    21,    26,
      32,    89,    32,    38,    37,    33,    38,    37,    89,    20,
      25,    18,    31,    31,    22,    29,    89,    33,    18,    35,
      18,    30,    22,    37,    22,    35,    -1,    18,    38,    21,
      26,    32,    89,    32,    38,    37,    33,    38,    37,    89,
      20,    25,    18,    31,    31,    22,    29,    -1,    18,    38,
      21,    26,    32,    89,    32,    38,    37,    33,    38,    37,
      89,    37,    42,    33,    22,    -1,    18,    39,    18,    26,
      29,    18,    19,    29,    22,    89,    30,    26,    21,    26,
      89,    26,    31,    33,    38,    37,    89,    21,    35,    26,
      39,    22,    35,    36,    -1,    30,    26,    21,    26,    89,
      26,    31,    33,    38,    37,    89,    21,    22,    39,    26,
      20,    22,    89,    33,    18,    35,    18,    30,    22,    37,
      22,    35,    -1,    30,    26,    21,    26,    89,    26,    31,
      33,    38,    37,    89,    33,    32,    35,    37,    89,    33,
      18,    35,    18,    30,    22,    37,    22,    35,    -1,    30,
      26,    21,    26,    89,    26,    31,    33,    38,    37,    89,
      21,    22,    39,    26,    20,    22,    36,    -1,    30,    26,
      21,    26,    89,    26,    31,    33,    38,    37,    89,    21,
      22,    39,    26,    20,    22,    -1,    30,    26,    21,    26,
      89,    26,    31,    33,    38,    37,    89,    21,    35,    26,
      39,    22,    35,    89,    33,    18,    35,    18,    30,    22,
      37,    22,    35,    -1,    30,    26,    21,    26,    89,    26,
      31,    33,    38,    37,    89,    21,    35,    26,    39,    22,
      35,    -1,    30,    26,    21,    26,    89,    26,    31,    33,
      38,    37,    89,    33,    32,    35,    37,    -1,    30,    26,
      21,    26,    89,    26,    31,    33,    38,    37,    89,    20,
      25,    18,    31,    31,    22,    29,    -1,    30,    26,    21,
      26,    89,    26,    31,    33,    38,    37,    89,    37,    42,
      33,    22,    -1,    30,    26,    21,    26,    89,    26,    31,
      33,    38,    37,    -1,    39,    32,    29,    38,    30,    22,
      -1,    19,    42,    37,    22,    36,    -1,    33,    22,    35,
      20,    22,    31,    37,    18,    24,    22,    -1,    35,    22,
      36,    22,    37,    -1,    30,    26,    36,    20,    22,    29,
      29,    18,    31,    22,    32,    38,    36,    -1,    22,    20,
      25,    32,    -1,    34,    38,    26,    37,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    81,    81,    82,    85,    86,    87,    88,    91,    92,
      93,    94,    95,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   114,   115,   116,
     117,   118,   119,   122,   123,   124,   125,   126,   127,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   155,   156,   157,   158,   159,   160,   163,   164,
     165,   166,   169,   170,   173,   174,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   188,   189,   192,   193,   196,
     197,   198,   201,   202,   205,   208,   211,   214,   217,   220,
     221,   224,   227,   228,   231,   234,   237,   240,   243,   244,
     245,   246,   252,   253,   256,   257,   260,   261,   262,   266,
     267,   270,   271,   272,   273,   274,   275,   276,   277,   278,
     279,   282,   283,   284,   285,   286,   287,   288,   289,   290,
     291,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   293,   293,   293,
     293,   293,   293,   293,   293,   293,   293,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   294,   294,   294,   294,   294,   294,   294,
     294,   294,   294,   295,   295,   295,   295,   295,   295,   295,
     295,   295,   295,   296,   296,   296,   296,   296,   296,   296,
     296,   296,   296,   296,   296,   296,   297,   297,   297,   297,
     297,   297,   297,   298,   298,   298,   298,   298,   299,   299,
     299,   299,   300,   300,   300,   301,   301,   301,   302,   302,
     302,   303,   303,   303,   304,   304,   304,   305,   305,   305,
     306,   306,   306,   307,   307,   307,   308,   308,   308,   309,
     309,   309,   310,   310,   310,   311,   311,   311,   312,   312,
     312,   313,   313,   313,   314,   314,   314,   315,   315,   315,
     316,   316,   316,   317,   317,   317,   318,   318,   318,   319,
     319,   319,   320,   320,   320,   321,   321,   321,   322,   322,
     322,   323,   323,   323,   324,   324,   324,   325,   325,   325,
     326,   326,   326,   327,   327,   327,   328,   328,   328,   329,
     329,   329,   330,   330,   330,   331,   331,   331,   332,   332,
     332,   333,   333,   333,   334,   334,   334,   335,   335,   335,
     336,   336,   336,   337,   337,   337,   338,   338,   338,   339,
     339,   339,   340,   340,   340,   341,   341,   341,   342,   342,
     345,   346,   347,   348,   351,   352,   358,   361,   364,   367,
     370,   373,   376,   379,   382,   385,   388,   391,   394,   397,
     400,   403,   406,   409,   412,   415,   418,   421,   424,   427,
     430,   433,   436,   439,   442,   445,   448,   451,   454,   457,
     460,   463,   466,   469,   472,   475,   478,   481,   484,   487,
     490,   493,   496,   499,   502,   505,   508,   511
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "'#'", "'='", "'.'", "'+'", "'-'", "'0'",
  "'1'", "'2'", "'3'", "'4'", "'5'", "'6'", "'7'", "'8'", "'9'", "'A'",
  "'B'", "'C'", "'D'", "'E'", "'F'", "'G'", "'H'", "'I'", "'J'", "'K'",
  "'L'", "'M'", "'N'", "'O'", "'P'", "'Q'", "'R'", "'S'", "'T'", "'U'",
  "'V'", "'W'", "'X'", "'Y'", "'Z'", "'a'", "'b'", "'c'", "'d'", "'e'",
  "'f'", "'g'", "'h'", "'i'", "'j'", "'k'", "'l'", "'m'", "'n'", "'o'",
  "'p'", "'q'", "'r'", "'s'", "'t'", "'u'", "'v'", "'w'", "'x'", "'y'",
  "'z'", "'!'", "'$'", "'%'", "'&'", "'('", "')'", "'*'", "','", "'/'",
  "':'", "';'", "'<'", "'>'", "'?'", "'@'", "'['", "'\\\\'", "']'", "'^'",
  "'_'", "'{'", "'|'", "'}'", "'~'", "'\\200'", "'\\201'", "'\\202'",
  "'\\203'", "'\\204'", "'\\205'", "'\\206'", "'\\207'", "'\\210'",
  "'\\211'", "'\\212'", "'\\213'", "'\\214'", "'\\215'", "'\\216'",
  "'\\217'", "'\\220'", "'\\221'", "'\\222'", "'\\223'", "'\\224'",
  "'\\225'", "'\\226'", "'\\227'", "'\\230'", "'\\231'", "'\\232'",
  "'\\233'", "'\\234'", "'\\235'", "'\\236'", "'\\237'", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "''", "''", "''", "''", "''", "''",
  "''", "''", "''", "''", "'''", "'\"'", "' '", "'\\n'", "'\\r'",
  "$accept", "input", "line", "comment", "command", "subscribe_event",
  "unsubscribe_event", "get_instruction", "set_instruction",
  "create_instruction", "destroy_instruction", "load_instruction",
  "set_chan_instruction", "key_val_list", "buffer_size_type",
  "list_instruction", "load_instr_args", "load_engine_args",
  "device_index", "audio_channel_index", "audio_output_type_name",
  "midi_input_port_index", "midi_input_channel_index",
  "midi_input_type_name", "volume_value", "sampler_channel",
  "instrument_index", "engine_name", "filename", "param_val", "boolean",
  "string", "dotnum", "digits", "digit", "number", "char", "text",
  "stringval", "SP", "LF", "CR", "ADD", "GET", "CREATE", "DESTROY", "LIST",
  "LOAD", "ALL", "NON_MODAL", "REMOVE", "SET", "SUBSCRIBE", "UNSUBSCRIBE",
  "SELECT", "CHANNEL", "AVAILABLE_ENGINES",
  "AVAILABLE_AUDIO_OUTPUT_DRIVERS", "CHANNELS", "INFO", "BUFFER_FILL",
  "STREAM_COUNT", "VOICE_COUNT", "INSTRUMENT", "ENGINE",
  "AUDIO_OUTPUT_DEVICE_PARAMETER", "AUDIO_OUTPUT_DEVICES",
  "AUDIO_OUTPUT_DEVICE", "AUDIO_OUTPUT_DRIVER_PARAMETER",
  "AUDIO_OUTPUT_DRIVER", "AUDIO_OUTPUT_CHANNEL_PARAMETER",
  "AUDIO_OUTPUT_CHANNEL", "AUDIO_OUTPUT_TYPE",
  "AVAILABLE_MIDI_INPUT_DRIVERS", "MIDI_INPUT_DEVICE_PARAMETER",
  "MIDI_INPUT_PORT_PARAMETER", "MIDI_INPUT_DEVICES", "MIDI_INPUT_DEVICE",
  "MIDI_INPUT_DRIVER_PARAMETER", "MIDI_INPUT_DRIVER", "MIDI_INPUT_PORT",
  "MIDI_INPUT_CHANNEL", "MIDI_INPUT_TYPE", "MIDI_INPUT", "VOLUME", "BYTES",
  "PERCENTAGE", "RESET", "MISCELLANEOUS", "ECHO", "QUIT", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,    35,    61,    46,    43,    45,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
      33,    36,    37,    38,    40,    41,    42,    44,    47,    58,
      59,    60,    62,    63,    64,    91,    92,    93,    94,    95,
     123,   124,   125,   126,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,    39,    34,    32,    10,    13
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned short int yyr1[] =
{
       0,   227,   228,   228,   229,   229,   229,   229,   230,   230,
     230,   230,   230,   231,   231,   231,   231,   231,   231,   231,
     231,   231,   231,   231,   231,   231,   231,   232,   232,   232,
     232,   232,   232,   233,   233,   233,   233,   233,   233,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   234,   234,   234,   234,   234,   234,   234,   234,
     234,   234,   235,   235,   235,   235,   235,   235,   236,   236,
     236,   236,   237,   237,   238,   238,   239,   239,   239,   239,
     239,   239,   239,   239,   239,   240,   240,   241,   241,   242,
     242,   242,   243,   243,   244,   245,   246,   247,   248,   249,
     249,   250,   251,   251,   252,   253,   254,   255,   256,   256,
     256,   256,   257,   257,   258,   258,   259,   259,   259,   260,
     260,   261,   261,   261,   261,   261,   261,   261,   261,   261,
     261,   262,   262,   262,   262,   262,   262,   262,   262,   262,
     262,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,   263,   263,   263,   263,   263,   263,   263,   263,
     264,   264,   264,   264,   265,   265,   266,   267,   268,   269,
     270,   271,   272,   273,   274,   275,   276,   277,   278,   279,
     280,   281,   282,   283,   284,   285,   286,   287,   288,   289,
     290,   291,   292,   293,   294,   295,   296,   297,   298,   299,
     300,   301,   302,   303,   304,   305,   306,   307,   308,   309,
     310,   311,   312,   313,   314,   315,   316,   317
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     3,     0,     1,     1,     1,     1,     2,
       2,     2,     2,     3,     3,     3,     3,     3,     3,     5,
       3,     3,     3,     3,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     5,     7,     9,     1,     5,     7,     9,     1,     1,
       5,     5,     7,     9,     7,     9,     1,     5,     7,     5,
       5,     5,     7,     9,     7,     9,     3,     3,     5,     3,
       5,     3,     3,     3,     3,     3,     5,     7,     5,     9,
       5,     5,     5,     5,     5,     3,     5,     1,     1,     1,
       1,     1,     5,     7,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     2,     3,     4,     4,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     2,     2,     3,     3,     1,     1,     1,     3,
       3,     6,     7,     4,     4,     3,     9,     6,     3,     9,
      11,     6,     7,    17,    30,     8,     4,    11,    12,    11,
      10,     6,    29,    20,    19,    29,    19,    30,    20,    17,
      28,    27,    25,    18,    17,    27,    17,    15,    18,    15,
      10,     6,     5,    10,     5,    13,     4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short int yydefact[] =
{
       0,     7,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     5,     6,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    25,    26,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       1,   367,   368,     2,     0,     9,   219,   213,   211,   212,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   203,   205,   206,   207,   208,   209,   210,   214,
     215,   216,   217,   218,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,   264,   265,
     266,   267,   268,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   366,    12,   131,    11,   114,    10,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   369,     0,     0,   370,     0,     0,     0,     0,
       0,     0,   378,     0,     0,     3,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   132,   119,   133,   134,
     135,   136,   137,   138,   139,   140,   204,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   115,     0,    13,
       0,     0,     0,     0,    14,     0,    39,    44,    56,     0,
      48,     0,     0,     0,     0,     0,    40,     0,    49,     0,
       0,     0,     0,     0,     0,    15,     0,     0,    16,     0,
       0,     0,     0,     0,    17,    91,    89,    90,     0,    18,
       0,     0,     0,     0,     0,     0,    20,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    21,    27,
      31,    30,    29,    28,    32,    22,    33,    37,    36,    35,
      34,    38,   361,    23,   360,     0,     0,     0,   373,   374,
     417,     0,     0,     0,     0,     0,   120,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   363,   362,     0,     0,     0,     0,   414,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    69,    71,   122,   123,   124,
     125,   126,   127,   128,   129,   130,    72,    73,     0,     0,
       0,     0,     0,     0,     0,    74,     0,   107,     0,    75,
       0,   106,    19,   104,     0,     0,     0,     0,     0,     0,
      66,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,    67,   113,   112,     0,     0,     0,
       0,     0,    24,   371,     0,   377,   381,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   416,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   386,     0,     0,     0,   372,     0,
       0,     0,     0,     0,     0,     0,     0,    57,     0,     0,
       0,    87,    88,    59,    60,    61,    50,     0,    45,     0,
       0,     0,    51,     0,    41,     0,     0,     0,    68,     0,
      70,     0,     0,     0,     0,     0,   364,   365,     0,   105,
       0,    94,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     391,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   379,     0,   382,     0,     0,   382,
       0,     0,     0,    58,    46,     0,    54,     0,    42,    52,
       0,     0,     0,   211,   212,    85,   108,   111,     0,   119,
     110,   109,     0,     0,     0,     0,     0,    92,     0,     0,
       0,     0,     0,     0,    76,    95,     0,    96,    78,    97,
      80,    81,    98,     0,    82,    99,   100,    83,   101,     0,
       0,     0,    84,   102,   103,    62,     0,    64,     0,     0,
       0,     0,     0,     0,     0,     0,   385,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   411,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   380,
       0,     0,     0,   412,     0,    47,    55,    53,    43,     0,
       0,    86,     0,     0,   116,     0,     0,     0,     0,    93,
       0,     0,     0,     0,    77,   375,     0,    63,    65,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   117,
     118,     0,     0,   390,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   376,     0,     0,     0,     0,    79,
     387,     0,     0,   389,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   410,
       0,   388,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   415,
       0,     0,     0,     0,     0,     0,     0,     0,   413,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   407,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   383,     0,   404,
     406,     0,     0,   404,     0,     0,     0,     0,     0,     0,
       0,     0,   407,   409,     0,     0,     0,     0,     0,   403,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,   394,   396,     0,     0,     0,     0,   394,     0,     0,
       0,     0,     0,   399,     0,   398,   393,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   408,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   398,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   402,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     405,     0,   401,     0,     0,     0,   400,     0,     0,   395,
       0,   392,   397,   384
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,    12,    13,    14,    15,   388,   395,   334,   376,   355,
     358,   369,   530,   648,   630,   364,   515,   519,   774,   776,
     778,   781,   784,   787,   792,   522,   658,   520,   516,   755,
     544,   756,   757,   758,   266,   523,   268,   403,   761,   703,
      43,    44,    16,    17,    18,    19,    20,    21,   786,   518,
      22,    23,    24,    25,    26,   329,   336,   337,   338,   390,
     391,   392,   393,   370,   339,   378,   340,   341,   342,   343,
     344,   345,   533,   346,   380,   347,   348,   349,   350,   351,
     352,   536,   537,   538,   539,   631,   632,    27,   394,   382,
      28
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -705
static const short int yypact[] =
{
      55,  -705,  -705,    12,    25,    33,    80,    31,    39,    82,
       1,   101,   109,  -173,  1578,  -705,   -64,   -64,   -64,   -64,
     -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,  -705,   182,
     171,   194,   207,   209,   228,   221,    97,    -1,   252,   234,
    -705,  -705,  -705,  -705,    47,  -705,  -705,  -705,  -705,  -705,
    -705,   241,   241,   241,   241,   241,   241,   241,   241,   241,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  2243,  -705,  -705,  -705,  -705,
     253,     7,    78,    78,    65,   200,   253,   106,    62,    62,
    1800,   253,  -705,   256,   238,  -705,   239,   257,   240,   247,
     260,   261,  -705,   248,   249,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,   241,  -705,   241,   241,
     241,   241,   241,   241,   241,   241,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,   263,  -705,
      96,   264,   254,   265,  -705,   -64,  -705,  -705,  -705,   -64,
    -705,   -64,   -64,   -64,   -64,   -64,  -705,   -64,  -705,   -64,
     -64,   -64,   -64,   255,   266,  -705,   -64,   -64,  -705,   -64,
     -64,   259,   269,   280,  -705,  -705,  -705,  -705,   276,  -705,
     -64,   -64,   -64,   270,   275,   283,  -705,   -64,   -64,   -64,
     -64,   -64,   -64,   272,   281,   285,   278,   258,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  2243,  1800,  -705,   -64,   279,   282,  -705,  -705,
    -705,   274,   284,   294,   298,   267,  -705,   301,   299,   304,
     305,   302,   306,    61,   303,   303,   303,   303,   303,   303,
     303,   303,   303,   303,   303,   314,   321,  2243,  2243,   251,
     251,   322,   307,   326,   308,   -27,  2243,   251,   329,   327,
     330,    20,   251,   251,   251,   251,  2462,   331,   332,   317,
     328,   338,  2243,  -705,   251,   334,   325,   336,  -705,   335,
     339,   337,   344,   350,   351,   347,   353,   354,   -64,   -64,
     -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,
     -64,   -64,   -64,   355,   356,  1800,  1800,   241,   241,   241,
     241,   241,   241,   241,   241,   241,  -705,  -705,   357,   358,
     359,   349,   333,  1800,  1800,  -705,   -64,  -705,   -64,  -705,
     -64,  2243,  -705,  -705,   361,   352,   362,   360,   364,   363,
    -705,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,   -64,
     -64,   -64,   -64,   -64,  -705,  2243,  -705,   368,   365,   373,
     374,   379,  -705,  -705,   366,  -705,  -705,   375,   380,   371,
     372,   376,   378,   381,   318,   251,    21,   251,   251,  2243,
     251,  2243,  2243,   251,   251,   251,   251,  2243,  2243,   251,
     382,   324,  2243,  2243,   383,   385,   340,   384,   386,  1134,
    1356,   251,   -44,   251,   388,  -705,   341,   389,   390,   377,
     251,   251,   251,   251,   251,   251,   251,   251,   251,  2243,
     251,  2243,   251,   396,  -705,   399,   404,   401,  -705,   405,
     392,   406,   342,   414,   411,   412,   409,  -705,   394,   415,
     -64,  -705,  -705,  -705,  -705,  -705,  -705,  1800,  2243,   -64,
     -64,   -64,  -705,  1800,  2243,   -64,   367,   417,   -64,  2681,
     -64,   369,   422,   419,   408,   370,  -705,  -705,   -64,  -705,
     -64,  -705,   393,   421,   423,   424,   410,   -64,   -64,   -64,
     -64,   -64,   -64,   -64,   -64,   -64,  2900,   -64,  3119,   -64,
     416,   425,   427,   397,   430,   429,   431,   432,   434,   433,
    -705,   435,   426,   448,   251,  2243,   251,   251,   251,  2243,
     251,   464,   466,  2243,  2022,   467,   436,   469,   468,   471,
     251,   251,   472,   475,   476,   444,   489,   251,   251,  2243,
     251,   251,   225,  2243,   251,   201,  2022,  2243,  2022,  2243,
     445,   506,   447,   441,  -705,   518,  -705,   500,   510,   504,
     508,   521,   524,  -705,  1800,   -64,  -705,   -64,  1800,  -705,
     507,   513,  3338,   241,   241,  -705,  2243,  -705,   105,   -34,
    -705,  -705,   509,   504,   515,   527,   519,  -705,   -64,   512,
     520,   463,   528,   533,  -705,  -705,   -64,  -705,  -705,  2243,
    -705,  -705,  -705,   529,  -705,  -705,  -705,  -705,  2243,   -64,
     241,   241,  -705,  -705,  -705,  -705,  3557,  -705,  3776,   534,
     545,   544,   535,   546,   532,   548,  -705,   536,   530,   549,
    2243,  2243,  2243,  2243,   538,   542,  2022,   142,   172,   241,
     539,   543,   541,   552,   251,   547,   550,   551,   554,  -705,
     251,   553,   251,  2022,  2022,   560,   556,   557,   555,  -705,
     558,   501,   562,  -705,   561,   -64,  2243,  2243,   -64,   564,
     563,  -705,   241,   241,   241,   568,   565,   567,   576,  -705,
     572,   569,   570,   574,  -705,  -705,   -64,  -705,  -705,   566,
     587,   573,   579,   575,   176,   523,   577,   578,   526,   241,
     241,   580,   531,  -705,   588,   583,   559,   585,   586,   225,
     594,   593,   596,   598,   599,   595,   600,   611,    90,   620,
     602,   619,   604,   621,  -705,   606,   104,   612,   607,  -705,
    -705,   608,   613,  -705,   581,   630,   628,   632,    64,   622,
     631,   582,   643,   584,   645,   589,   647,   640,   636,   591,
     639,  -705,   128,   650,   651,   655,   646,   661,   653,   667,
     670,   654,   671,   656,   181,   657,   663,   662,    41,  -705,
     675,    72,   669,   674,   624,   676,   678,   672,  -705,   697,
     694,   699,   696,   698,   702,   701,   688,   641,   703,   700,
     687,   713,   706,   709,   649,   718,   715,   722,   724,   658,
     710,   730,   712,   732,   735,   716,   734,   658,    14,   738,
     723,   726,   731,   737,   725,   736,   739,   740,   748,   741,
     744,   756,   752,   757,   762,   754,   760,   765,   763,   747,
     759,   755,   769,   764,   773,   772,   758,  -705,   766,   761,
     711,   783,   785,  -705,   790,   761,   780,   792,   728,   795,
     781,   784,  -705,  -705,   799,   803,   791,   793,   789,  -705,
     796,   798,   806,   809,   812,   813,   805,   808,   818,   819,
     816,   810,   767,   814,   811,   831,   832,  -705,   810,   822,
     768,   834,   823,  -705,   824,   770,  -705,   825,   826,   771,
     827,   833,   770,   828,   836,   845,  -705,   835,   854,   837,
     852,   858,   855,   860,   861,   851,   863,   847,   794,   849,
     856,   848,   853,   857,  -705,   862,   871,   869,   865,   874,
     876,   875,   877,   884,   873,   872,   870,   867,   881,   878,
     880,   888,   889,   893,   900,   901,  -705,   902,   903,   905,
     891,   890,   895,   896,   898,   904,   899,   911,   915,   906,
    -705,   916,  -705,   918,   908,   909,  -705,   910,   912,  -705,
     913,  -705,  -705,  -705
};

/* YYPGOTO[NTERM-NUM].  */
static const short int yypgoto[] =
{
    -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -582,  -705,  -705,  -705,  -705,  -497,  -427,
    -705,   114,    52,  -705,  -705,  -462,   199,   387,   391,  -704,
    -705,   323,   223,    13,   -10,   -14,   277,  -293,  -419,   -11,
     907,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,  -705,
    -705,  -705,  -705,  -705,  -705,   -52,  -705,  -705,   -74,  -262,
    -249,  -248,  -247,  -705,   677,  -705,   680,  -254,  -705,  -705,
     673,   511,  -705,  -705,  -705,   681,   683,  -252,  -705,  -705,
     514,  -705,  -705,  -705,  -705,  -705,  -705,  -705,   682,  -705,
    -705
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -132
static const short int yytable[] =
{
     267,   650,   552,   269,   512,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   397,   356,   359,
     357,   360,   795,    37,   797,   330,   517,   331,   291,   332,
     398,   399,   400,    29,  1008,   959,   292,   333,   527,    38,
     628,   307,   307,   307,   307,   307,   307,   307,   307,   307,
     528,  1009,    41,    42,   629,    31,     1,    33,     2,   529,
      30,   968,   922,    34,   306,   308,   309,   310,   311,   312,
     313,   314,   315,     3,   969,     4,     5,    35,   970,     6,
     383,   383,   362,   361,     7,   362,   936,   384,   384,     8,
       9,    10,   385,    11,   972,   363,   353,   386,   386,   937,
     387,   387,    32,   627,    36,   633,   634,   973,   354,    40,
     819,   918,   851,   296,   297,   298,   299,   300,   301,   302,
     303,   304,   305,   919,   373,   926,   328,   289,   374,   867,
     868,   661,    39,   290,   418,   419,   375,   927,   667,   668,
     669,   670,   671,   672,   673,   674,   675,   852,   950,   951,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     264,   478,   482,   483,   484,   485,   486,   487,   488,   489,
     490,   491,   492,   517,   479,   480,   481,   853,   513,   514,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
    -131,  -131,  -131,   283,   895,   513,   514,   531,   896,   534,
     365,   963,   964,   282,   389,   396,   897,   790,   791,   296,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   335,
     589,   590,   332,   780,   372,   377,   368,   789,   845,   405,
     284,   848,   743,   296,   497,   498,   499,   500,   501,   502,
     503,   504,   505,   783,   285,   286,   287,   288,   767,   296,
     297,   298,   299,   300,   301,   302,   303,   304,   305,   296,
     497,   498,   499,   500,   501,   502,   503,   504,   505,   404,
     294,   293,    41,   328,   406,   407,   408,   410,   409,   411,
      -4,    -4,   412,   413,   414,   421,   471,   415,   417,   420,
     461,   422,   436,   435,   442,   449,   416,   441,   416,   416,
     416,   416,   416,   416,   416,   416,   443,   444,   448,   450,
     457,   459,   458,   467,   469,   460,   465,   466,   470,   472,
     473,   468,   474,   475,   423,   509,   476,   477,   424,   384,
     425,   426,   427,   428,   429,   493,   430,   265,   431,   432,
     433,   434,   494,   508,   511,   437,   438,   510,   439,   440,
     524,   526,   525,   549,   547,   548,   553,   554,   555,   445,
     446,   447,   859,   550,   551,   588,   451,   452,   453,   454,
     455,   456,   556,   558,   557,   559,   560,   561,   562,   563,
     564,   580,   581,   584,   595,   586,   587,   594,   596,   585,
     598,   613,   463,   615,   464,   599,   616,   614,   597,   617,
     620,   619,   621,   864,   622,   623,   666,   626,   618,   624,
     664,   665,   625,   647,   646,   651,   652,   655,   680,   654,
     662,   681,   682,   683,   684,   506,   507,   685,   686,   653,
     663,   687,   688,   689,   690,   691,   692,   693,   540,   541,
     542,   543,   546,   702,   706,   707,   708,   713,   716,   714,
     715,   730,   734,   738,   731,   735,   701,   732,   705,   709,
     736,   802,   739,   741,   737,   763,   740,   565,   566,   567,
     568,   569,   570,   571,   572,   573,   574,   575,   576,   577,
     578,   579,   712,   742,   582,   583,   733,   307,   307,   307,
     307,   307,   307,   307,   307,   307,   750,   751,   765,   762,
     764,   766,   404,   404,   769,   591,   770,   592,   771,   593,
     306,   308,   309,   310,   311,   312,   313,   314,   315,   773,
     600,   601,   602,   603,   604,   605,   606,   607,   608,   609,
     610,   611,   612,   772,   799,   800,   801,   803,   804,   805,
     806,   807,   327,   808,   809,   814,   815,   820,   821,   822,
     825,   823,   827,   826,   828,   829,   636,   835,   831,   639,
     640,   641,   642,   836,   837,   645,   843,   838,   839,   840,
     841,   844,   857,   858,   842,   849,   855,   659,   463,   463,
     850,   856,   865,   862,   860,   863,   869,   870,   861,   871,
     874,   873,   876,   872,   884,   890,   677,   877,   679,   875,
     878,   881,   882,   402,   883,   885,   886,   888,   887,   891,
     893,   892,   898,   894,   899,   901,   900,   904,   902,   694,
     903,   905,   907,   910,   908,   911,   695,   912,   696,   697,
     698,   916,   699,   915,   700,   913,   914,   917,   920,   921,
     922,   923,   924,   925,   929,   928,   930,   710,   906,   711,
     931,   933,   934,   935,   938,   939,   717,   718,   719,   720,
     721,   722,   723,   724,   725,   941,   727,   943,   729,   945,
     932,   940,   946,   942,   947,   949,   952,   953,   944,   327,
     948,   954,   745,   746,   747,   955,   749,   956,   957,   958,
     760,   959,   961,   960,   759,   962,   965,   659,   966,   967,
     971,   974,   977,   775,   777,   975,   775,   782,   785,   979,
     775,   794,   760,   976,   760,   759,   759,   978,   759,   980,
     981,   982,   983,   984,   985,   987,   462,   986,   989,   991,
     988,   992,   990,   810,   811,   994,   812,   813,   995,   327,
     996,   997,   998,   307,   307,   993,   999,  1000,   416,  1001,
    1002,  1003,  1004,  1005,  1007,  1006,  1010,   824,  1011,  1012,
     495,   496,  1013,  1014,  1015,   830,   817,   818,  1016,   521,
    1019,  1018,   327,   327,  1023,  1017,  1020,  1021,   832,   545,
     307,   307,  1022,  1024,  1025,  1026,  1027,  1028,  1029,  1030,
    1031,  1033,  1032,  1035,  1036,  1034,  1037,  1039,   327,  1038,
    1040,  1041,   760,   817,   818,  1042,   759,   416,   416,   307,
    1043,  1044,  1045,  1047,  1048,  1049,   777,  1046,   782,   760,
     760,  1050,   327,   759,   759,  1051,  1052,  1054,  1057,  1055,
    1053,  1058,   854,  1056,  1059,  1060,   402,   402,  1061,  1062,
    1063,  1064,   307,   307,   416,  1065,  1066,  1068,  1069,  1070,
    1071,  1072,  1074,  1076,  1075,   889,  1067,  1073,  1078,  1077,
    1080,  1083,  1081,  1082,  1079,   879,   880,  1085,  1086,   416,
     416,  1084,  1087,  1089,  1088,   785,  1090,  1091,  1092,  1093,
    1094,  1095,  1096,  1097,  1098,  1100,  1099,  1102,  1101,  1104,
    1105,  1106,   521,  1109,   637,   638,  1107,  1103,  1108,  1110,
     643,   644,  1111,  1112,  1115,   649,   649,  1113,  1117,  1114,
     768,  1120,   462,   462,   327,   327,  1116,  1118,  1119,  1121,
     327,   327,  1122,  1123,  1124,  1125,   327,  1126,  1127,  1128,
    1129,  1130,   676,  1134,   678,  1131,  1133,  1135,  1137,  1132,
    1138,   909,  1136,  1139,  1140,  1141,   866,  1142,   793,  1143,
     379,   295,   371,   327,   366,   327,   635,   367,   381,     0,
       0,   401,   532,     0,     0,   535,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   660,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   744,     0,
       0,   327,   748,     0,     0,   327,   752,     0,     0,   327,
       0,     0,     0,   327,     0,     0,     0,     0,     0,     0,
       0,     0,   779,     0,     0,     0,   788,     0,     0,     0,
     796,     0,   798,     0,     0,     0,   327,     0,     0,     0,
       0,     0,     0,     0,     0,   327,     0,     0,     0,     0,
       0,     0,     0,   327,     0,   327,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   327,   327,     0,     0,     0,     0,     0,
       0,     0,     0,   649,   846,   847,   649,   316,    46,    47,
      48,    49,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,   224,   225,   226,   227,
     228,   229,   230,   231,   232,   233,   234,   235,   236,   237,
     238,   239,   240,   241,   242,   243,   244,   245,   246,   247,
     248,   249,   250,   251,   252,   253,   254,   255,   256,   257,
     258,   259,   260,   261,   262,   263,   656,     0,   264,   316,
      46,    47,    48,    49,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263,     0,   657,
     264,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
       0,     0,   264,   316,    46,    47,    48,    49,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,     0,     0,   264,   316,    46,    47,   753,   754,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   513,   514,   316,    46,    47,    48,
      49,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,   222,   223,   224,   225,   226,   227,   228,
     229,   230,   231,   232,   233,   234,   235,   236,   237,   238,
     239,   240,   241,   242,   243,   244,   245,   246,   247,   248,
     249,   250,   251,   252,   253,   254,   255,   256,   257,   258,
     259,   260,   261,   262,   263,   316,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,   222,   223,   224,   225,   226,   227,   228,   229,
     230,   231,   232,   233,   234,   235,   236,   237,   238,   239,
     240,   241,   242,   243,   244,   245,   246,   247,   248,   249,
     250,   251,   252,   253,   254,   255,   256,   257,   258,   259,
     260,   261,   262,   263,   316,   704,    47,    48,    49,   317,
     318,   319,   320,   321,   322,   323,   324,   325,   326,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,   222,   223,   224,   225,   226,   227,   228,   229,   230,
     231,   232,   233,   234,   235,   236,   237,   238,   239,   240,
     241,   242,   243,   244,   245,   246,   247,   248,   249,   250,
     251,   252,   253,   254,   255,   256,   257,   258,   259,   260,
     261,   262,   263,   316,   726,    47,    48,    49,   317,   318,
     319,   320,   321,   322,   323,   324,   325,   326,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
     222,   223,   224,   225,   226,   227,   228,   229,   230,   231,
     232,   233,   234,   235,   236,   237,   238,   239,   240,   241,
     242,   243,   244,   245,   246,   247,   248,   249,   250,   251,
     252,   253,   254,   255,   256,   257,   258,   259,   260,   261,
     262,   263,   316,   728,    47,    48,    49,   317,   318,   319,
     320,   321,   322,   323,   324,   325,   326,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,   222,
     223,   224,   225,   226,   227,   228,   229,   230,   231,   232,
     233,   234,   235,   236,   237,   238,   239,   240,   241,   242,
     243,   244,   245,   246,   247,   248,   249,   250,   251,   252,
     253,   254,   255,   256,   257,   258,   259,   260,   261,   262,
     263,   316,   816,    47,    48,    49,   317,   318,   319,   320,
     321,   322,   323,   324,   325,   326,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,   222,   223,
     224,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   245,   246,   247,   248,   249,   250,   251,   252,   253,
     254,   255,   256,   257,   258,   259,   260,   261,   262,   263,
     316,   833,    47,    48,    49,   317,   318,   319,   320,   321,
     322,   323,   324,   325,   326,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100,   101,   102,   103,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,   114,
     115,   116,   117,   118,   119,   120,   121,   122,   123,   124,
     125,   126,   127,   128,   129,   130,   131,   132,   133,   134,
     135,   136,   137,   138,   139,   140,   141,   142,   143,   144,
     145,   146,   147,   148,   149,   150,   151,   152,   153,   154,
     155,   156,   157,   158,   159,   160,   161,   162,   163,   164,
     165,   166,   167,   168,   169,   170,   171,   172,   173,   174,
     175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
     185,   186,   187,   188,   189,   190,   191,   192,   193,   194,
     195,   196,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,   209,   210,   211,   212,   213,   214,
     215,   216,   217,   218,   219,   220,   221,   222,   223,   224,
     225,   226,   227,   228,   229,   230,   231,   232,   233,   234,
     235,   236,   237,   238,   239,   240,   241,   242,   243,   244,
     245,   246,   247,   248,   249,   250,   251,   252,   253,   254,
     255,   256,   257,   258,   259,   260,   261,   262,   263,   316,
     834,    47,    48,    49,   317,   318,   319,   320,   321,   322,
     323,   324,   325,   326,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,   223,   224,   225,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   242,   243,   244,   245,
     246,   247,   248,   249,   250,   251,   252,   253,   254,   255,
     256,   257,   258,   259,   260,   261,   262,   263
};

static const short int yycheck[] =
{
      14,   583,   464,    14,    31,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,   279,   272,   273,
     272,   273,   726,    22,   728,    18,   445,    20,    29,    22,
     279,   279,   279,    21,    20,    21,    37,    30,    18,    38,
      19,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      30,    37,   225,   226,    33,    22,     1,    26,     3,    39,
      35,    20,    21,    32,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    18,    33,    20,    21,    38,    37,    24,
      19,    19,    20,    18,    29,    20,    22,    26,    26,    34,
      35,    36,    30,    38,    22,    30,    18,    36,    36,    35,
      39,    39,    22,   565,    22,   567,   568,    35,    30,     0,
       5,    21,   816,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    33,    18,    21,    20,    30,    22,   833,
     834,   593,    31,    36,    38,    39,    30,    33,   600,   601,
     602,   603,   604,   605,   606,   607,   608,     5,    20,    21,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
     224,   423,   424,   425,   426,   427,   428,   429,   430,   431,
     432,   433,   434,   592,   423,   423,   423,     5,   222,   223,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
     224,   225,   226,    22,    18,   222,   223,   451,    22,   451,
     274,    20,    21,    21,   278,   279,    30,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,   271,
     513,   514,    22,   720,   276,   277,    26,   724,   810,   281,
      36,   813,   694,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    37,    36,    18,    26,   710,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,   280,
      36,    19,   225,    20,    18,    37,    37,    37,    21,    32,
     225,   226,    22,    22,    36,    31,    19,    38,    25,    25,
      32,    26,    26,    38,    25,    20,   306,    38,   308,   309,
     310,   311,   312,   313,   314,   315,    26,    31,    38,    26,
      38,    26,    31,    39,    20,    37,    37,    35,    20,    18,
      21,    37,    18,    18,   335,    18,    24,    21,   339,    26,
     341,   342,   343,   344,   345,    21,   347,    14,   349,   350,
     351,   352,    21,    21,    36,   356,   357,    21,   359,   360,
      21,    21,    25,    36,    23,    23,    22,    32,    22,   370,
     371,   372,   824,    35,    26,    32,   377,   378,   379,   380,
     381,   382,    37,    36,    35,    31,    26,    26,    31,    26,
      26,    26,    26,    26,    32,    26,    37,    26,    26,    31,
      26,    23,   403,    20,   405,    32,    22,    32,    38,    20,
      20,    26,    31,   830,    32,    29,    29,    89,    42,    31,
      21,    21,    31,    89,    32,    32,    31,    31,    22,    35,
      32,    22,    18,    22,    19,   439,   440,    35,    22,    89,
      89,    89,    18,    22,    22,    26,    42,    22,   452,   453,
     454,   455,   456,    26,    22,    26,    38,    26,    38,    26,
      26,    35,    22,    19,    29,    26,    89,    30,    89,    89,
      29,    20,    29,    37,    32,    29,    31,   478,   479,   480,
     481,   482,   483,   484,   485,   486,   487,   488,   489,   490,
     491,   492,    89,    35,   495,   496,    89,   497,   498,   499,
     500,   501,   502,   503,   504,   505,    32,    31,    30,    32,
      31,    30,   513,   514,    32,   516,    31,   518,    32,   520,
     497,   498,   499,   500,   501,   502,   503,   504,   505,    30,
     531,   532,   533,   534,   535,   536,   537,   538,   539,   540,
     541,   542,   543,    89,    89,    29,    89,    19,    38,    29,
      36,    33,   265,    22,    20,    38,    33,    38,    33,    22,
      38,    32,    89,    33,    26,    22,   570,    23,    29,   573,
     574,   575,   576,    18,    20,   579,    36,    32,    22,    37,
      22,    22,    31,    21,    38,    37,    37,   591,   589,   590,
      38,    38,    29,    32,    37,    31,    26,    31,    38,    32,
      89,    33,    31,    38,    18,    29,   610,    33,   612,    37,
      37,    33,    37,   280,    37,    33,    37,    33,    38,    22,
      31,    38,    89,    38,    37,    89,    38,    29,    38,   630,
      89,    38,    37,    29,    38,    32,   637,    31,   639,   640,
     641,    31,   643,    38,   645,    37,    37,    26,    18,    37,
      21,    37,    21,    37,    37,    33,    38,   658,    89,   660,
      37,    21,    24,    21,    32,    24,   667,   668,   669,   670,
     671,   672,   673,   674,   675,    22,   677,    22,   679,    22,
      89,    89,    32,    89,    38,    36,    26,    26,    89,   402,
      89,    26,   696,   697,   698,    39,   700,    26,    35,    22,
     704,    21,    21,    39,   704,    39,    39,   711,    35,    37,
      25,    32,    26,   717,   718,    31,   720,   721,   722,    37,
     724,   725,   726,    89,   728,   725,   726,    39,   728,    22,
      26,    22,    26,    25,    22,    37,   403,    26,    25,    42,
      89,    18,    32,   744,   745,    26,   747,   748,    89,   462,
      22,    26,    20,   753,   754,    39,    22,    89,   758,    39,
      20,    39,    20,    18,    20,    39,    18,   768,    35,    33,
     437,   438,    31,    26,    39,   776,   753,   754,    32,   446,
      22,    31,   495,   496,    22,    36,    35,    33,   789,   456,
     790,   791,    26,    26,    22,    31,    26,    22,    25,    42,
      31,    22,    37,    20,    22,    31,    38,    36,   521,    33,
      89,    18,   816,   790,   791,    20,   816,   817,   818,   819,
      20,    31,    20,    18,    33,    31,   830,    89,   832,   833,
     834,    22,   545,   833,   834,    22,    35,    38,    22,    33,
      37,    22,   819,    35,    22,    22,   513,   514,    33,    31,
      22,    22,   852,   853,   854,    29,    36,    33,    37,    18,
      18,    29,    18,    29,    31,   866,    89,    89,    33,    89,
      89,    33,    35,    30,    38,   852,   853,    22,    33,   879,
     880,    35,    18,    21,    37,   889,    18,    22,    18,    18,
      29,    18,    35,    89,    35,    37,    30,    30,    35,    18,
      21,    26,   569,    18,   571,   572,    22,    35,    22,    22,
     577,   578,    18,    30,    37,   582,   583,    35,    30,    39,
     711,    22,   589,   590,   637,   638,    35,    37,    30,    26,
     643,   644,    22,    22,    22,    22,   649,    22,    37,    39,
      35,    35,   609,    22,   611,    37,    37,    22,    22,    35,
      22,   889,    36,    35,    35,    35,   832,    35,   725,    36,
     277,    44,   275,   676,   274,   678,   569,   274,   277,    -1,
      -1,   279,   451,    -1,    -1,   451,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   592,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   695,    -1,
      -1,   744,   699,    -1,    -1,   748,   703,    -1,    -1,   752,
      -1,    -1,    -1,   756,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   719,    -1,    -1,    -1,   723,    -1,    -1,    -1,
     727,    -1,   729,    -1,    -1,    -1,   779,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,   788,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   796,    -1,   798,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   846,   847,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,   810,   811,   812,   813,     3,     4,     5,
       6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
      26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
      36,    37,    38,    39,    40,    41,    42,    43,    44,    45,
      46,    47,    48,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,    59,    60,    61,    62,    63,    64,    65,
      66,    67,    68,    69,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,    80,    81,    82,    83,    84,    85,
      86,    87,    88,    89,    90,    91,    92,    93,    94,    95,
      96,    97,    98,    99,   100,   101,   102,   103,   104,   105,
     106,   107,   108,   109,   110,   111,   112,   113,   114,   115,
     116,   117,   118,   119,   120,   121,   122,   123,   124,   125,
     126,   127,   128,   129,   130,   131,   132,   133,   134,   135,
     136,   137,   138,   139,   140,   141,   142,   143,   144,   145,
     146,   147,   148,   149,   150,   151,   152,   153,   154,   155,
     156,   157,   158,   159,   160,   161,   162,   163,   164,   165,
     166,   167,   168,   169,   170,   171,   172,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   184,   185,
     186,   187,   188,   189,   190,   191,   192,   193,   194,   195,
     196,   197,   198,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   213,   214,   215,
     216,   217,   218,   219,   220,   221,   222,    -1,   224,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221,    -1,   223,
     224,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
      -1,    -1,   224,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,    -1,    -1,   224,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   222,   223,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    35,    36,
      37,    38,    39,    40,    41,    42,    43,    44,    45,    46,
      47,    48,    49,    50,    51,    52,    53,    54,    55,    56,
      57,    58,    59,    60,    61,    62,    63,    64,    65,    66,
      67,    68,    69,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,    80,    81,    82,    83,    84,    85,    86,
      87,    88,    89,    90,    91,    92,    93,    94,    95,    96,
      97,    98,    99,   100,   101,   102,   103,   104,   105,   106,
     107,   108,   109,   110,   111,   112,   113,   114,   115,   116,
     117,   118,   119,   120,   121,   122,   123,   124,   125,   126,
     127,   128,   129,   130,   131,   132,   133,   134,   135,   136,
     137,   138,   139,   140,   141,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   158,   159,   160,   161,   162,   163,   164,   165,   166,
     167,   168,   169,   170,   171,   172,   173,   174,   175,   176,
     177,   178,   179,   180,   181,   182,   183,   184,   185,   186,
     187,   188,   189,   190,   191,   192,   193,   194,   195,   196,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   209,   210,   211,   212,   213,   214,   215,   216,
     217,   218,   219,   220,   221,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,     3,     4,     5,     6,     7,     8,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    21,    22,    23,    24,    25,    26,    27,    28,
      29,    30,    31,    32,    33,    34,    35,    36,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    47,    48,
      49,    50,    51,    52,    53,    54,    55,    56,    57,    58,
      59,    60,    61,    62,    63,    64,    65,    66,    67,    68,
      69,    70,    71,    72,    73,    74,    75,    76,    77,    78,
      79,    80,    81,    82,    83,    84,    85,    86,    87,    88,
      89,    90,    91,    92,    93,    94,    95,    96,    97,    98,
      99,   100,   101,   102,   103,   104,   105,   106,   107,   108,
     109,   110,   111,   112,   113,   114,   115,   116,   117,   118,
     119,   120,   121,   122,   123,   124,   125,   126,   127,   128,
     129,   130,   131,   132,   133,   134,   135,   136,   137,   138,
     139,   140,   141,   142,   143,   144,   145,   146,   147,   148,
     149,   150,   151,   152,   153,   154,   155,   156,   157,   158,
     159,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     169,   170,   171,   172,   173,   174,   175,   176,   177,   178,
     179,   180,   181,   182,   183,   184,   185,   186,   187,   188,
     189,   190,   191,   192,   193,   194,   195,   196,   197,   198,
     199,   200,   201,   202,   203,   204,   205,   206,   207,   208,
     209,   210,   211,   212,   213,   214,   215,   216,   217,   218,
     219,   220,   221,     3,     4,     5,     6,     7,     8,     9,
      10,    11,    12,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    35,    36,    37,    38,    39,
      40,    41,    42,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,    53,    54,    55,    56,    57,    58,    59,
      60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
      70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
      80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    94,    95,    96,    97,    98,    99,
     100,   101,   102,   103,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   114,   115,   116,   117,   118,   119,
     120,   121,   122,   123,   124,   125,   126,   127,   128,   129,
     130,   131,   132,   133,   134,   135,   136,   137,   138,   139,
     140,   141,   142,   143,   144,   145,   146,   147,   148,   149,
     150,   151,   152,   153,   154,   155,   156,   157,   158,   159,
     160,   161,   162,   163,   164,   165,   166,   167,   168,   169,
     170,   171,   172,   173,   174,   175,   176,   177,   178,   179,
     180,   181,   182,   183,   184,   185,   186,   187,   188,   189,
     190,   191,   192,   193,   194,   195,   196,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,   209,
     210,   211,   212,   213,   214,   215,   216,   217,   218,   219,
     220,   221,     3,     4,     5,     6,     7,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      31,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    53,    54,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,    72,    73,    74,    75,    76,    77,    78,    79,    80,
      81,    82,    83,    84,    85,    86,    87,    88,    89,    90,
      91,    92,    93,    94,    95,    96,    97,    98,    99,   100,
     101,   102,   103,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   114,   115,   116,   117,   118,   119,   120,
     121,   122,   123,   124,   125,   126,   127,   128,   129,   130,
     131,   132,   133,   134,   135,   136,   137,   138,   139,   140,
     141,   142,   143,   144,   145,   146,   147,   148,   149,   150,
     151,   152,   153,   154,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,   165,   166,   167,   168,   169,   170,
     171,   172,   173,   174,   175,   176,   177,   178,   179,   180,
     181,   182,   183,   184,   185,   186,   187,   188,   189,   190,
     191,   192,   193,   194,   195,   196,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,   209,   210,
     211,   212,   213,   214,   215,   216,   217,   218,   219,   220,
     221,     3,     4,     5,     6,     7,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    21,
      22,    23,    24,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,    35,    36,    37,    38,    39,    40,    41,
      42,    43,    44,    45,    46,    47,    48,    49,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    61,
      62,    63,    64,    65,    66,    67,    68,    69,    70,    71,
      72,    73,    74,    75,    76,    77,    78,    79,    80,    81,
      82,    83,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,    96,    97,    98,    99,   100,   101,
     102,   103,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   115,   116,   117,   118,   119,   120,   121,
     122,   123,   124,   125,   126,   127,   128,   129,   130,   131,
     132,   133,   134,   135,   136,   137,   138,   139,   140,   141,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   151,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   168,   169,   170,   171,
     172,   173,   174,   175,   176,   177,   178,   179,   180,   181,
     182,   183,   184,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   194,   195,   196,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,   209,   210,   211,
     212,   213,   214,   215,   216,   217,   218,   219,   220,   221,
       3,     4,     5,     6,     7,     8,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    35,    36,    37,    38,    39,    40,    41,    42,
      43,    44,    45,    46,    47,    48,    49,    50,    51,    52,
      53,    54,    55,    56,    57,    58,    59,    60,    61,    62,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    75,    76,    77,    78,    79,    80,    81,    82,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,    96,    97,    98,    99,   100,   101,   102,
     103,   104,   105,   106,   107,   108,   109,   110,   111,   112,
     113,   114,   115,   116,   117,   118,   119,   120,   121,   122,
     123,   124,   125,   126,   127,   128,   129,   130,   131,   132,
     133,   134,   135,   136,   137,   138,   139,   140,   141,   142,
     143,   144,   145,   146,   147,   148,   149,   150,   151,   152,
     153,   154,   155,   156,   157,   158,   159,   160,   161,   162,
     163,   164,   165,   166,   167,   168,   169,   170,   171,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   186,   187,   188,   189,   190,   191,   192,
     193,   194,   195,   196,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   212,
     213,   214,   215,   216,   217,   218,   219,   220,   221,     3,
       4,     5,     6,     7,     8,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    21,    22,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116,   117,   118,   119,   120,   121,   122,   123,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   143,
     144,   145,   146,   147,   148,   149,   150,   151,   152,   153,
     154,   155,   156,   157,   158,   159,   160,   161,   162,   163,
     164,   165,   166,   167,   168,   169,   170,   171,   172,   173,
     174,   175,   176,   177,   178,   179,   180,   181,   182,   183,
     184,   185,   186,   187,   188,   189,   190,   191,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   210,   211,   212,   213,
     214,   215,   216,   217,   218,   219,   220,   221
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned short int yystos[] =
{
       0,     1,     3,    18,    20,    21,    24,    29,    34,    35,
      36,    38,   228,   229,   230,   231,   269,   270,   271,   272,
     273,   274,   277,   278,   279,   280,   281,   314,   317,    21,
      35,    22,    22,    26,    32,    38,    22,    22,    38,    31,
       0,   225,   226,   267,   268,     3,     4,     5,     6,     7,
       8,     9,    10,    11,    12,    13,    14,    15,    16,    17,
      18,    19,    20,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    33,    34,    35,    36,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
      68,    69,    70,    71,    72,    73,    74,    75,    76,    77,
      78,    79,    80,    81,    82,    83,    84,    85,    86,    87,
      88,    89,    90,    91,    92,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   103,   104,   105,   106,   107,
     108,   109,   110,   111,   112,   113,   114,   115,   116,   117,
     118,   119,   120,   121,   122,   123,   124,   125,   126,   127,
     128,   129,   130,   131,   132,   133,   134,   135,   136,   137,
     138,   139,   140,   141,   142,   143,   144,   145,   146,   147,
     148,   149,   150,   151,   152,   153,   154,   155,   156,   157,
     158,   159,   160,   161,   162,   163,   164,   165,   166,   167,
     168,   169,   170,   171,   172,   173,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   185,   186,   187,
     188,   189,   190,   191,   192,   193,   194,   195,   196,   197,
     198,   199,   200,   201,   202,   203,   204,   205,   206,   207,
     208,   209,   210,   211,   212,   213,   214,   215,   216,   217,
     218,   219,   220,   221,   224,   258,   261,   262,   263,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,    21,    22,    36,    37,    36,    18,    26,    30,
      36,    29,    37,    19,    36,   267,     8,     9,    10,    11,
      12,    13,    14,    15,    16,    17,   260,   261,   260,   260,
     260,   260,   260,   260,   260,   260,     3,     8,     9,    10,
      11,    12,    13,    14,    15,    16,    17,   263,    20,   282,
      18,    20,    22,    30,   234,   282,   283,   284,   285,   291,
     293,   294,   295,   296,   297,   298,   300,   302,   303,   304,
     305,   306,   307,    18,    30,   236,   294,   304,   237,   294,
     304,    18,    20,    30,   242,   285,   293,   303,    26,   238,
     290,   291,   282,    18,    22,    30,   235,   282,   292,   297,
     301,   302,   316,    19,    26,    30,    36,    39,   232,   285,
     286,   287,   288,   289,   315,   233,   285,   286,   287,   288,
     289,   315,   258,   264,   266,   282,    18,    37,    37,    21,
      37,    32,    22,    22,    36,    38,   261,    25,    38,    39,
      25,    31,    26,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,    38,    26,   266,   266,   266,
     266,    38,    25,    26,    31,   266,   266,   266,    38,    20,
      26,   266,   266,   266,   266,   266,   266,    38,    31,    26,
      37,    32,   258,   266,   266,    37,    35,    39,    37,    20,
      20,    19,    18,    21,    18,    18,    24,    21,   286,   287,
     288,   289,   286,   286,   286,   286,   286,   286,   286,   286,
     286,   286,   286,    21,    21,   258,   258,     9,    10,    11,
      12,    13,    14,    15,    16,    17,   262,   262,    21,    18,
      21,    36,    31,   222,   223,   243,   255,   265,   276,   244,
     254,   258,   252,   262,    21,    25,    21,    18,    30,    39,
     239,   294,   298,   299,   304,   307,   308,   309,   310,   311,
     262,   262,   262,   262,   257,   258,   262,    23,    23,    36,
      35,    26,   252,    22,    32,    22,    37,    35,    36,    31,
      26,    26,    31,    26,    26,   266,   266,   266,   266,   266,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
      26,    26,   266,   266,    26,    31,    26,    37,    32,   264,
     264,   266,   266,   266,    26,    32,    26,    38,    26,    32,
     266,   266,   266,   266,   266,   266,   266,   266,   266,   266,
     266,   266,   266,    23,    32,    20,    22,    20,    42,    26,
      20,    31,    32,    29,    31,    31,    89,   252,    19,    33,
     241,   312,   313,   252,   252,   254,   262,   258,   258,   262,
     262,   262,   262,   258,   258,   262,    32,    89,   240,   258,
     240,    32,    31,    89,    35,    31,   222,   223,   253,   262,
     255,   252,    32,    89,    21,    21,    29,   252,   252,   252,
     252,   252,   252,   252,   252,   252,   258,   262,   258,   262,
      22,    22,    18,    22,    19,    35,    22,    89,    18,    22,
      22,    26,    42,    22,   266,   266,   266,   266,   266,   266,
     266,    89,    26,   266,     4,    89,    22,    26,    38,    89,
     266,   266,    89,    26,    26,    26,    38,   266,   266,   266,
     266,   266,   266,   266,   266,   266,     4,   266,     4,   266,
      35,    29,    30,    89,    22,    26,    29,    32,    19,    29,
      31,    37,    35,   252,   258,   262,   262,   262,   258,   262,
      32,    31,   258,     6,     7,   256,   258,   259,   260,   261,
     262,   265,    32,    29,    31,    30,    30,   252,   253,    32,
      31,    32,    89,    30,   245,   262,   246,   262,   247,   258,
     245,   248,   262,    18,   249,   262,   275,   250,   258,   245,
       6,     7,   251,   259,   262,   256,   258,   256,   258,    89,
      29,    89,    20,    19,    38,    29,    36,    33,    22,    20,
     266,   266,   266,   266,    38,    33,     4,   260,   260,     5,
      38,    33,    22,    32,   266,    38,    33,    89,    26,    22,
     266,    29,   266,     4,     4,    23,    18,    20,    32,    22,
      37,    22,    38,    36,    22,   240,   258,   258,   240,    37,
      38,   256,     5,     5,   260,    37,    38,    31,    21,   252,
      37,    38,    32,    31,   246,    29,   248,   256,   256,    26,
      31,    32,    38,    33,    89,    37,    31,    33,    37,   260,
     260,    33,    37,    37,    18,    33,    37,    38,    33,   266,
      29,    22,    38,    31,    38,    18,    22,    30,    89,    37,
      38,    89,    38,    89,    29,    38,    89,    37,    38,   249,
      29,    32,    31,    37,    37,    38,    31,    26,    21,    33,
      18,    37,    21,    37,    21,    37,    21,    33,    33,    37,
      38,    37,    89,    21,    24,    21,    22,    35,    32,    24,
      89,    22,    89,    22,    89,    22,    32,    38,    89,    36,
      20,    21,    26,    26,    26,    39,    26,    35,    22,    21,
      39,    21,    39,    20,    21,    39,    35,    37,    20,    33,
      37,    25,    22,    35,    32,    31,    89,    26,    39,    37,
      22,    26,    22,    26,    25,    22,    26,    37,    89,    25,
      32,    42,    18,    39,    26,    89,    22,    26,    20,    22,
      89,    39,    20,    39,    20,    18,    39,    20,    20,    37,
      18,    35,    33,    31,    26,    39,    32,    36,    31,    22,
      35,    33,    26,    22,    26,    22,    31,    26,    22,    25,
      42,    31,    37,    22,    31,    20,    22,    38,    33,    36,
      89,    18,    20,    20,    31,    20,    89,    18,    33,    31,
      22,    22,    35,    37,    38,    33,    35,    22,    22,    22,
      22,    33,    31,    22,    22,    29,    36,    89,    33,    37,
      18,    18,    29,    89,    18,    31,    29,    89,    33,    38,
      89,    35,    30,    33,    35,    22,    33,    18,    37,    21,
      18,    22,    18,    18,    29,    18,    35,    89,    35,    30,
      37,    35,    30,    35,    18,    21,    26,    22,    22,    18,
      22,    18,    30,    35,    39,    37,    35,    30,    37,    30,
      22,    26,    22,    22,    22,    22,    22,    37,    39,    35,
      35,    37,    35,    37,    22,    22,    36,    22,    22,    35,
      35,    35,    35,    36
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */






/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  register short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;


  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:
#line 85 "lscp.y"
    { return LSCP_DONE; }
    break;

  case 5:
#line 86 "lscp.y"
    { return LSCP_DONE; }
    break;

  case 6:
#line 87 "lscp.y"
    { LSCPSERVER->AnswerClient(yyvsp[0].String); return LSCP_DONE; }
    break;

  case 7:
#line 88 "lscp.y"
    { LSCPSERVER->AnswerClient("Err:0:Unknown command.\r\n"); RESTART; return LSCP_SYNTAX_ERROR; }
    break;

  case 13:
#line 98 "lscp.y"
    { yyval.String = LSCPSERVER->AddChannel();                          }
    break;

  case 14:
#line 99 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 15:
#line 100 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 16:
#line 101 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 17:
#line 102 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 18:
#line 103 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 19:
#line 104 "lscp.y"
    { yyval.String = LSCPSERVER->RemoveChannel(yyvsp[0].Number);                     }
    break;

  case 20:
#line 105 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 21:
#line 106 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 22:
#line 107 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                }
    break;

  case 23:
#line 108 "lscp.y"
    { yyval.String = LSCPSERVER->QueryDatabase(yyvsp[0].String);                     }
    break;

  case 24:
#line 109 "lscp.y"
    { yyval.String = LSCPSERVER->ResetChannel(yyvsp[0].Number);                      }
    break;

  case 25:
#line 110 "lscp.y"
    { yyval.String = LSCPSERVER->ResetSampler();                        }
    break;

  case 26:
#line 111 "lscp.y"
    { LSCPSERVER->AnswerClient("Bye!\r\n"); return LSCP_QUIT; }
    break;

  case 27:
#line 114 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_channels);     }
    break;

  case 28:
#line 115 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_voice_count);  }
    break;

  case 29:
#line 116 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_stream_count); }
    break;

  case 30:
#line 117 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_buffer_fill);  }
    break;

  case 31:
#line 118 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_info);         }
    break;

  case 32:
#line 119 "lscp.y"
    { yyval.String = LSCPSERVER->SubscribeNotification(LSCPEvent::event_misc);         }
    break;

  case 33:
#line 122 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_channels);     }
    break;

  case 34:
#line 123 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_voice_count);  }
    break;

  case 35:
#line 124 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_stream_count); }
    break;

  case 36:
#line 125 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_buffer_fill);  }
    break;

  case 37:
#line 126 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_info);         }
    break;

  case 38:
#line 127 "lscp.y"
    { yyval.String = LSCPSERVER->UnsubscribeNotification(LSCPEvent::event_misc);         }
    break;

  case 39:
#line 130 "lscp.y"
    { yyval.String = LSCPSERVER->GetAvailableEngines();                          }
    break;

  case 40:
#line 131 "lscp.y"
    { yyval.String = LSCPSERVER->GetAvailableMidiInputDrivers();                 }
    break;

  case 41:
#line 132 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDriverInfo(yyvsp[0].String);                     }
    break;

  case 42:
#line 133 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDriverParameterInfo(yyvsp[-2].String, yyvsp[0].String);        }
    break;

  case 43:
#line 134 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDriverParameterInfo(yyvsp[-4].String, yyvsp[-2].String, yyvsp[0].KeyValList);    }
    break;

  case 44:
#line 135 "lscp.y"
    { yyval.String = LSCPSERVER->GetAvailableAudioOutputDrivers();               }
    break;

  case 45:
#line 136 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDriverInfo(yyvsp[0].String);                   }
    break;

  case 46:
#line 137 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDriverParameterInfo(yyvsp[-2].String, yyvsp[0].String);      }
    break;

  case 47:
#line 138 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDriverParameterInfo(yyvsp[-4].String, yyvsp[-2].String, yyvsp[0].KeyValList);  }
    break;

  case 48:
#line 139 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDeviceCount();                    }
    break;

  case 49:
#line 140 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDeviceCount();                      }
    break;

  case 50:
#line 141 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDeviceInfo(yyvsp[0].Number);                   }
    break;

  case 51:
#line 142 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDeviceInfo(yyvsp[0].Number);                     }
    break;

  case 52:
#line 143 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputPortInfo(yyvsp[-2].Number, yyvsp[0].Number);                   }
    break;

  case 53:
#line 144 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputPortParameterInfo(yyvsp[-4].Number, yyvsp[-2].Number, yyvsp[0].String);      }
    break;

  case 54:
#line 145 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputChannelInfo(yyvsp[-2].Number, yyvsp[0].Number);              }
    break;

  case 55:
#line 146 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputChannelParameterInfo(yyvsp[-4].Number, yyvsp[-2].Number, yyvsp[0].String); }
    break;

  case 56:
#line 147 "lscp.y"
    { yyval.String = LSCPSERVER->GetChannels();                                  }
    break;

  case 57:
#line 148 "lscp.y"
    { yyval.String = LSCPSERVER->GetChannelInfo(yyvsp[0].Number);                             }
    break;

  case 58:
#line 149 "lscp.y"
    { yyval.String = LSCPSERVER->GetBufferFill(yyvsp[-2].FillResponse, yyvsp[0].Number);                          }
    break;

  case 59:
#line 150 "lscp.y"
    { yyval.String = LSCPSERVER->GetStreamCount(yyvsp[0].Number);                             }
    break;

  case 60:
#line 151 "lscp.y"
    { yyval.String = LSCPSERVER->GetVoiceCount(yyvsp[0].Number);                              }
    break;

  case 61:
#line 152 "lscp.y"
    { yyval.String = LSCPSERVER->GetEngineInfo(yyvsp[0].String);                              }
    break;

  case 62:
#line 155 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputDeviceParameter(yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String);      }
    break;

  case 63:
#line 156 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputChannelParameter(yyvsp[-6].Number, yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String); }
    break;

  case 64:
#line 157 "lscp.y"
    { yyval.String = LSCPSERVER->SetMidiInputDeviceParameter(yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String);        }
    break;

  case 65:
#line 158 "lscp.y"
    { yyval.String = LSCPSERVER->SetMidiInputPortParameter(yyvsp[-6].Number, yyvsp[-4].Number, yyvsp[-2].String, yyvsp[0].String);      }
    break;

  case 66:
#line 159 "lscp.y"
    { yyval.String = yyvsp[0].String;                                                         }
    break;

  case 67:
#line 160 "lscp.y"
    { yyval.String = LSCPSERVER->SetEcho((yyparse_param_t*) yyparse_param, yyvsp[0].Dotnum);  }
    break;

  case 68:
#line 163 "lscp.y"
    { yyval.String = LSCPSERVER->CreateAudioOutputDevice(yyvsp[-2].String,yyvsp[0].KeyValList); }
    break;

  case 69:
#line 164 "lscp.y"
    { yyval.String = LSCPSERVER->CreateAudioOutputDevice(yyvsp[0].String);    }
    break;

  case 70:
#line 165 "lscp.y"
    { yyval.String = LSCPSERVER->CreateMidiInputDevice(yyvsp[-2].String,yyvsp[0].KeyValList);   }
    break;

  case 71:
#line 166 "lscp.y"
    { yyval.String = LSCPSERVER->CreateMidiInputDevice(yyvsp[0].String);      }
    break;

  case 72:
#line 169 "lscp.y"
    { yyval.String = LSCPSERVER->DestroyAudioOutputDevice(yyvsp[0].Number); }
    break;

  case 73:
#line 170 "lscp.y"
    { yyval.String = LSCPSERVER->DestroyMidiInputDevice(yyvsp[0].Number);   }
    break;

  case 74:
#line 173 "lscp.y"
    { yyval.String = yyvsp[0].String; }
    break;

  case 75:
#line 174 "lscp.y"
    { yyval.String = yyvsp[0].String; }
    break;

  case 76:
#line 177 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputDevice(yyvsp[0].Number, yyvsp[-2].Number);      }
    break;

  case 77:
#line 178 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputChannel(yyvsp[-2].Number, yyvsp[0].Number, yyvsp[-4].Number); }
    break;

  case 78:
#line 179 "lscp.y"
    { yyval.String = LSCPSERVER->SetAudioOutputType(yyvsp[0].String, yyvsp[-2].Number);        }
    break;

  case 79:
#line 180 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInput(yyvsp[-4].Number, yyvsp[-2].Number, yyvsp[0].Number, yyvsp[-6].Number);      }
    break;

  case 80:
#line 181 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputDevice(yyvsp[0].Number, yyvsp[-2].Number);        }
    break;

  case 81:
#line 182 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputPort(yyvsp[0].Number, yyvsp[-2].Number);          }
    break;

  case 82:
#line 183 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputChannel(yyvsp[0].Number, yyvsp[-2].Number);       }
    break;

  case 83:
#line 184 "lscp.y"
    { yyval.String = LSCPSERVER->SetMIDIInputType(yyvsp[0].String, yyvsp[-2].Number);          }
    break;

  case 84:
#line 185 "lscp.y"
    { yyval.String = LSCPSERVER->SetVolume(yyvsp[0].Dotnum, yyvsp[-2].Number);                 }
    break;

  case 85:
#line 188 "lscp.y"
    { yyval.KeyValList[yyvsp[-2].String] = yyvsp[0].String;          }
    break;

  case 86:
#line 189 "lscp.y"
    { yyval.KeyValList = yyvsp[-4].KeyValList; yyval.KeyValList[yyvsp[-2].String] = yyvsp[0].String; }
    break;

  case 87:
#line 192 "lscp.y"
    { yyval.FillResponse = fill_response_bytes;      }
    break;

  case 88:
#line 193 "lscp.y"
    { yyval.FillResponse = fill_response_percentage; }
    break;

  case 89:
#line 196 "lscp.y"
    { yyval.String = LSCPSERVER->GetAudioOutputDevices(); }
    break;

  case 90:
#line 197 "lscp.y"
    { yyval.String = LSCPSERVER->GetMidiInputDevices();   }
    break;

  case 91:
#line 198 "lscp.y"
    { yyval.String = LSCPSERVER->ListChannels();          }
    break;

  case 92:
#line 201 "lscp.y"
    { yyval.String = LSCPSERVER->LoadInstrument(yyvsp[-4].String, yyvsp[-2].Number, yyvsp[0].Number);       }
    break;

  case 93:
#line 202 "lscp.y"
    { yyval.String = LSCPSERVER->LoadInstrument(yyvsp[-4].String, yyvsp[-2].Number, yyvsp[0].Number, true); }
    break;

  case 94:
#line 205 "lscp.y"
    { yyval.String = LSCPSERVER->SetEngineType(yyvsp[-2].String, yyvsp[0].Number); }
    break;

  case 100:
#line 221 "lscp.y"
    { yyval.Number = 16; }
    break;

  case 103:
#line 228 "lscp.y"
    { yyval.Dotnum = yyvsp[0].Number; }
    break;

  case 110:
#line 245 "lscp.y"
    { std::stringstream ss; ss << yyvsp[0].Number; yyval.String = ss.str(); }
    break;

  case 111:
#line 246 "lscp.y"
    { std::stringstream ss; ss << yyvsp[0].Dotnum; yyval.String = ss.str(); }
    break;

  case 112:
#line 252 "lscp.y"
    { yyval.Dotnum = yyvsp[0].Number; }
    break;

  case 113:
#line 253 "lscp.y"
    { yyval.Dotnum = -1; }
    break;

  case 114:
#line 256 "lscp.y"
    { std::string s; s = yyvsp[0].Char; yyval.String = s; }
    break;

  case 115:
#line 257 "lscp.y"
    { yyval.String = yyvsp[-1].String + yyvsp[0].Char;                  }
    break;

  case 116:
#line 260 "lscp.y"
    { yyval.Dotnum = atof(String(yyvsp[-2].String + "." + yyvsp[0].String).c_str());                         }
    break;

  case 117:
#line 261 "lscp.y"
    { String s = "+"; s += yyvsp[-2].String; s += "."; s += yyvsp[0].String; yyval.Dotnum = atof(s.c_str()); }
    break;

  case 118:
#line 262 "lscp.y"
    { yyval.Dotnum = atof(String("-" + yyvsp[-2].String + "." + yyvsp[0].String).c_str());                   }
    break;

  case 119:
#line 266 "lscp.y"
    { yyval.String = yyvsp[0].Char;      }
    break;

  case 120:
#line 267 "lscp.y"
    { yyval.String = yyvsp[-1].String + yyvsp[0].Char; }
    break;

  case 121:
#line 270 "lscp.y"
    { yyval.Char = '0'; }
    break;

  case 122:
#line 271 "lscp.y"
    { yyval.Char = '1'; }
    break;

  case 123:
#line 272 "lscp.y"
    { yyval.Char = '2'; }
    break;

  case 124:
#line 273 "lscp.y"
    { yyval.Char = '3'; }
    break;

  case 125:
#line 274 "lscp.y"
    { yyval.Char = '4'; }
    break;

  case 126:
#line 275 "lscp.y"
    { yyval.Char = '5'; }
    break;

  case 127:
#line 276 "lscp.y"
    { yyval.Char = '6'; }
    break;

  case 128:
#line 277 "lscp.y"
    { yyval.Char = '7'; }
    break;

  case 129:
#line 278 "lscp.y"
    { yyval.Char = '8'; }
    break;

  case 130:
#line 279 "lscp.y"
    { yyval.Char = '9'; }
    break;

  case 131:
#line 282 "lscp.y"
    { yyval.Number = atoi(String(1, yyvsp[0].Char).c_str());      }
    break;

  case 132:
#line 283 "lscp.y"
    { yyval.Number = atoi(String(String("1") + yyvsp[0].String).c_str()); }
    break;

  case 133:
#line 284 "lscp.y"
    { yyval.Number = atoi(String(String("2") + yyvsp[0].String).c_str()); }
    break;

  case 134:
#line 285 "lscp.y"
    { yyval.Number = atoi(String(String("3") + yyvsp[0].String).c_str()); }
    break;

  case 135:
#line 286 "lscp.y"
    { yyval.Number = atoi(String(String("4") + yyvsp[0].String).c_str()); }
    break;

  case 136:
#line 287 "lscp.y"
    { yyval.Number = atoi(String(String("5") + yyvsp[0].String).c_str()); }
    break;

  case 137:
#line 288 "lscp.y"
    { yyval.Number = atoi(String(String("6") + yyvsp[0].String).c_str()); }
    break;

  case 138:
#line 289 "lscp.y"
    { yyval.Number = atoi(String(String("7") + yyvsp[0].String).c_str()); }
    break;

  case 139:
#line 290 "lscp.y"
    { yyval.Number = atoi(String(String("8") + yyvsp[0].String).c_str()); }
    break;

  case 140:
#line 291 "lscp.y"
    { yyval.Number = atoi(String(String("9") + yyvsp[0].String).c_str()); }
    break;

  case 141:
#line 293 "lscp.y"
    { yyval.Char = 'A'; }
    break;

  case 142:
#line 293 "lscp.y"
    { yyval.Char = 'B'; }
    break;

  case 143:
#line 293 "lscp.y"
    { yyval.Char = 'C'; }
    break;

  case 144:
#line 293 "lscp.y"
    { yyval.Char = 'D'; }
    break;

  case 145:
#line 293 "lscp.y"
    { yyval.Char = 'E'; }
    break;

  case 146:
#line 293 "lscp.y"
    { yyval.Char = 'F'; }
    break;

  case 147:
#line 293 "lscp.y"
    { yyval.Char = 'G'; }
    break;

  case 148:
#line 293 "lscp.y"
    { yyval.Char = 'H'; }
    break;

  case 149:
#line 293 "lscp.y"
    { yyval.Char = 'I'; }
    break;

  case 150:
#line 293 "lscp.y"
    { yyval.Char = 'J'; }
    break;

  case 151:
#line 293 "lscp.y"
    { yyval.Char = 'K'; }
    break;

  case 152:
#line 293 "lscp.y"
    { yyval.Char = 'L'; }
    break;

  case 153:
#line 293 "lscp.y"
    { yyval.Char = 'M'; }
    break;

  case 154:
#line 293 "lscp.y"
    { yyval.Char = 'N'; }
    break;

  case 155:
#line 293 "lscp.y"
    { yyval.Char = 'O'; }
    break;

  case 156:
#line 293 "lscp.y"
    { yyval.Char = 'P'; }
    break;

  case 157:
#line 293 "lscp.y"
    { yyval.Char = 'Q'; }
    break;

  case 158:
#line 293 "lscp.y"
    { yyval.Char = 'R'; }
    break;

  case 159:
#line 293 "lscp.y"
    { yyval.Char = 'S'; }
    break;

  case 160:
#line 293 "lscp.y"
    { yyval.Char = 'T'; }
    break;

  case 161:
#line 293 "lscp.y"
    { yyval.Char = 'U'; }
    break;

  case 162:
#line 293 "lscp.y"
    { yyval.Char = 'V'; }
    break;

  case 163:
#line 293 "lscp.y"
    { yyval.Char = 'W'; }
    break;

  case 164:
#line 293 "lscp.y"
    { yyval.Char = 'X'; }
    break;

  case 165:
#line 293 "lscp.y"
    { yyval.Char = 'Y'; }
    break;

  case 166:
#line 293 "lscp.y"
    { yyval.Char = 'Z'; }
    break;

  case 167:
#line 294 "lscp.y"
    { yyval.Char = 'a'; }
    break;

  case 168:
#line 294 "lscp.y"
    { yyval.Char = 'b'; }
    break;

  case 169:
#line 294 "lscp.y"
    { yyval.Char = 'c'; }
    break;

  case 170:
#line 294 "lscp.y"
    { yyval.Char = 'd'; }
    break;

  case 171:
#line 294 "lscp.y"
    { yyval.Char = 'e'; }
    break;

  case 172:
#line 294 "lscp.y"
    { yyval.Char = 'f'; }
    break;

  case 173:
#line 294 "lscp.y"
    { yyval.Char = 'g'; }
    break;

  case 174:
#line 294 "lscp.y"
    { yyval.Char = 'h'; }
    break;

  case 175:
#line 294 "lscp.y"
    { yyval.Char = 'i'; }
    break;

  case 176:
#line 294 "lscp.y"
    { yyval.Char = 'j'; }
    break;

  case 177:
#line 294 "lscp.y"
    { yyval.Char = 'k'; }
    break;

  case 178:
#line 294 "lscp.y"
    { yyval.Char = 'l'; }
    break;

  case 179:
#line 294 "lscp.y"
    { yyval.Char = 'm'; }
    break;

  case 180:
#line 294 "lscp.y"
    { yyval.Char = 'n'; }
    break;

  case 181:
#line 294 "lscp.y"
    { yyval.Char = 'o'; }
    break;

  case 182:
#line 294 "lscp.y"
    { yyval.Char = 'p'; }
    break;

  case 183:
#line 294 "lscp.y"
    { yyval.Char = 'q'; }
    break;

  case 184:
#line 294 "lscp.y"
    { yyval.Char = 'r'; }
    break;

  case 185:
#line 294 "lscp.y"
    { yyval.Char = 's'; }
    break;

  case 186:
#line 294 "lscp.y"
    { yyval.Char = 't'; }
    break;

  case 187:
#line 294 "lscp.y"
    { yyval.Char = 'u'; }
    break;

  case 188:
#line 294 "lscp.y"
    { yyval.Char = 'v'; }
    break;

  case 189:
#line 294 "lscp.y"
    { yyval.Char = 'w'; }
    break;

  case 190:
#line 294 "lscp.y"
    { yyval.Char = 'x'; }
    break;

  case 191:
#line 294 "lscp.y"
    { yyval.Char = 'y'; }
    break;

  case 192:
#line 294 "lscp.y"
    { yyval.Char = 'z'; }
    break;

  case 193:
#line 295 "lscp.y"
    { yyval.Char = '0'; }
    break;

  case 194:
#line 295 "lscp.y"
    { yyval.Char = '1'; }
    break;

  case 195:
#line 295 "lscp.y"
    { yyval.Char = '2'; }
    break;

  case 196:
#line 295 "lscp.y"
    { yyval.Char = '3'; }
    break;

  case 197:
#line 295 "lscp.y"
    { yyval.Char = '4'; }
    break;

  case 198:
#line 295 "lscp.y"
    { yyval.Char = '5'; }
    break;

  case 199:
#line 295 "lscp.y"
    { yyval.Char = '6'; }
    break;

  case 200:
#line 295 "lscp.y"
    { yyval.Char = '7'; }
    break;

  case 201:
#line 295 "lscp.y"
    { yyval.Char = '8'; }
    break;

  case 202:
#line 295 "lscp.y"
    { yyval.Char = '9'; }
    break;

  case 203:
#line 296 "lscp.y"
    { yyval.Char = '!'; }
    break;

  case 204:
#line 296 "lscp.y"
    { yyval.Char = '#'; }
    break;

  case 205:
#line 296 "lscp.y"
    { yyval.Char = '$'; }
    break;

  case 206:
#line 296 "lscp.y"
    { yyval.Char = '%'; }
    break;

  case 207:
#line 296 "lscp.y"
    { yyval.Char = '&'; }
    break;

  case 208:
#line 296 "lscp.y"
    { yyval.Char = '('; }
    break;

  case 209:
#line 296 "lscp.y"
    { yyval.Char = ')'; }
    break;

  case 210:
#line 296 "lscp.y"
    { yyval.Char = '*'; }
    break;

  case 211:
#line 296 "lscp.y"
    { yyval.Char = '+'; }
    break;

  case 212:
#line 296 "lscp.y"
    { yyval.Char = '-'; }
    break;

  case 213:
#line 296 "lscp.y"
    { yyval.Char = '.'; }
    break;

  case 214:
#line 296 "lscp.y"
    { yyval.Char = ','; }
    break;

  case 215:
#line 296 "lscp.y"
    { yyval.Char = '/'; }
    break;

  case 216:
#line 297 "lscp.y"
    { yyval.Char = ':'; }
    break;

  case 217:
#line 297 "lscp.y"
    { yyval.Char = ';'; }
    break;

  case 218:
#line 297 "lscp.y"
    { yyval.Char = '<'; }
    break;

  case 219:
#line 297 "lscp.y"
    { yyval.Char = '='; }
    break;

  case 220:
#line 297 "lscp.y"
    { yyval.Char = '>'; }
    break;

  case 221:
#line 297 "lscp.y"
    { yyval.Char = '?'; }
    break;

  case 222:
#line 297 "lscp.y"
    { yyval.Char = '@'; }
    break;

  case 223:
#line 298 "lscp.y"
    { yyval.Char = '['; }
    break;

  case 224:
#line 298 "lscp.y"
    { yyval.Char = '\\'; }
    break;

  case 225:
#line 298 "lscp.y"
    { yyval.Char = ']'; }
    break;

  case 226:
#line 298 "lscp.y"
    { yyval.Char = '^'; }
    break;

  case 227:
#line 298 "lscp.y"
    { yyval.Char = '_'; }
    break;

  case 228:
#line 299 "lscp.y"
    { yyval.Char = '{'; }
    break;

  case 229:
#line 299 "lscp.y"
    { yyval.Char = '|'; }
    break;

  case 230:
#line 299 "lscp.y"
    { yyval.Char = '}'; }
    break;

  case 231:
#line 299 "lscp.y"
    { yyval.Char = '~'; }
    break;

  case 232:
#line 300 "lscp.y"
    { yyval.Char = '\200'; }
    break;

  case 233:
#line 300 "lscp.y"
    { yyval.Char = '\201'; }
    break;

  case 234:
#line 300 "lscp.y"
    { yyval.Char = '\202'; }
    break;

  case 235:
#line 301 "lscp.y"
    { yyval.Char = '\203'; }
    break;

  case 236:
#line 301 "lscp.y"
    { yyval.Char = '\204'; }
    break;

  case 237:
#line 301 "lscp.y"
    { yyval.Char = '\205'; }
    break;

  case 238:
#line 302 "lscp.y"
    { yyval.Char = '\206'; }
    break;

  case 239:
#line 302 "lscp.y"
    { yyval.Char = '\207'; }
    break;

  case 240:
#line 302 "lscp.y"
    { yyval.Char = '\210'; }
    break;

  case 241:
#line 303 "lscp.y"
    { yyval.Char = '\211'; }
    break;

  case 242:
#line 303 "lscp.y"
    { yyval.Char = '\212'; }
    break;

  case 243:
#line 303 "lscp.y"
    { yyval.Char = '\213'; }
    break;

  case 244:
#line 304 "lscp.y"
    { yyval.Char = '\214'; }
    break;

  case 245:
#line 304 "lscp.y"
    { yyval.Char = '\215'; }
    break;

  case 246:
#line 304 "lscp.y"
    { yyval.Char = '\216'; }
    break;

  case 247:
#line 305 "lscp.y"
    { yyval.Char = '\217'; }
    break;

  case 248:
#line 305 "lscp.y"
    { yyval.Char = '\220'; }
    break;

  case 249:
#line 305 "lscp.y"
    { yyval.Char = '\221'; }
    break;

  case 250:
#line 306 "lscp.y"
    { yyval.Char = '\222'; }
    break;

  case 251:
#line 306 "lscp.y"
    { yyval.Char = '\223'; }
    break;

  case 252:
#line 306 "lscp.y"
    { yyval.Char = '\224'; }
    break;

  case 253:
#line 307 "lscp.y"
    { yyval.Char = '\225'; }
    break;

  case 254:
#line 307 "lscp.y"
    { yyval.Char = '\226'; }
    break;

  case 255:
#line 307 "lscp.y"
    { yyval.Char = '\227'; }
    break;

  case 256:
#line 308 "lscp.y"
    { yyval.Char = '\230'; }
    break;

  case 257:
#line 308 "lscp.y"
    { yyval.Char = '\231'; }
    break;

  case 258:
#line 308 "lscp.y"
    { yyval.Char = '\232'; }
    break;

  case 259:
#line 309 "lscp.y"
    { yyval.Char = '\233'; }
    break;

  case 260:
#line 309 "lscp.y"
    { yyval.Char = '\234'; }
    break;

  case 261:
#line 309 "lscp.y"
    { yyval.Char = '\235'; }
    break;

  case 262:
#line 310 "lscp.y"
    { yyval.Char = '\236'; }
    break;

  case 263:
#line 310 "lscp.y"
    { yyval.Char = '\237'; }
    break;

  case 264:
#line 310 "lscp.y"
    { yyval.Char = '\240'; }
    break;

  case 265:
#line 311 "lscp.y"
    { yyval.Char = '\241'; }
    break;

  case 266:
#line 311 "lscp.y"
    { yyval.Char = '\242'; }
    break;

  case 267:
#line 311 "lscp.y"
    { yyval.Char = '\243'; }
    break;

  case 268:
#line 312 "lscp.y"
    { yyval.Char = '\244'; }
    break;

  case 269:
#line 312 "lscp.y"
    { yyval.Char = '\245'; }
    break;

  case 270:
#line 312 "lscp.y"
    { yyval.Char = '\246'; }
    break;

  case 271:
#line 313 "lscp.y"
    { yyval.Char = '\247'; }
    break;

  case 272:
#line 313 "lscp.y"
    { yyval.Char = '\250'; }
    break;

  case 273:
#line 313 "lscp.y"
    { yyval.Char = '\251'; }
    break;

  case 274:
#line 314 "lscp.y"
    { yyval.Char = '\252'; }
    break;

  case 275:
#line 314 "lscp.y"
    { yyval.Char = '\253'; }
    break;

  case 276:
#line 314 "lscp.y"
    { yyval.Char = '\254'; }
    break;

  case 277:
#line 315 "lscp.y"
    { yyval.Char = '\255'; }
    break;

  case 278:
#line 315 "lscp.y"
    { yyval.Char = '\256'; }
    break;

  case 279:
#line 315 "lscp.y"
    { yyval.Char = '\257'; }
    break;

  case 280:
#line 316 "lscp.y"
    { yyval.Char = '\260'; }
    break;

  case 281:
#line 316 "lscp.y"
    { yyval.Char = '\261'; }
    break;

  case 282:
#line 316 "lscp.y"
    { yyval.Char = '\262'; }
    break;

  case 283:
#line 317 "lscp.y"
    { yyval.Char = '\263'; }
    break;

  case 284:
#line 317 "lscp.y"
    { yyval.Char = '\264'; }
    break;

  case 285:
#line 317 "lscp.y"
    { yyval.Char = '\265'; }
    break;

  case 286:
#line 318 "lscp.y"
    { yyval.Char = '\266'; }
    break;

  case 287:
#line 318 "lscp.y"
    { yyval.Char = '\267'; }
    break;

  case 288:
#line 318 "lscp.y"
    { yyval.Char = '\270'; }
    break;

  case 289:
#line 319 "lscp.y"
    { yyval.Char = '\271'; }
    break;

  case 290:
#line 319 "lscp.y"
    { yyval.Char = '\272'; }
    break;

  case 291:
#line 319 "lscp.y"
    { yyval.Char = '\273'; }
    break;

  case 292:
#line 320 "lscp.y"
    { yyval.Char = '\274'; }
    break;

  case 293:
#line 320 "lscp.y"
    { yyval.Char = '\275'; }
    break;

  case 294:
#line 320 "lscp.y"
    { yyval.Char = '\276'; }
    break;

  case 295:
#line 321 "lscp.y"
    { yyval.Char = '\277'; }
    break;

  case 296:
#line 321 "lscp.y"
    { yyval.Char = '\300'; }
    break;

  case 297:
#line 321 "lscp.y"
    { yyval.Char = '\301'; }
    break;

  case 298:
#line 322 "lscp.y"
    { yyval.Char = '\302'; }
    break;

  case 299:
#line 322 "lscp.y"
    { yyval.Char = '\303'; }
    break;

  case 300:
#line 322 "lscp.y"
    { yyval.Char = '\304'; }
    break;

  case 301:
#line 323 "lscp.y"
    { yyval.Char = '\305'; }
    break;

  case 302:
#line 323 "lscp.y"
    { yyval.Char = '\306'; }
    break;

  case 303:
#line 323 "lscp.y"
    { yyval.Char = '\307'; }
    break;

  case 304:
#line 324 "lscp.y"
    { yyval.Char = '\310'; }
    break;

  case 305:
#line 324 "lscp.y"
    { yyval.Char = '\311'; }
    break;

  case 306:
#line 324 "lscp.y"
    { yyval.Char = '\312'; }
    break;

  case 307:
#line 325 "lscp.y"
    { yyval.Char = '\313'; }
    break;

  case 308:
#line 325 "lscp.y"
    { yyval.Char = '\314'; }
    break;

  case 309:
#line 325 "lscp.y"
    { yyval.Char = '\315'; }
    break;

  case 310:
#line 326 "lscp.y"
    { yyval.Char = '\316'; }
    break;

  case 311:
#line 326 "lscp.y"
    { yyval.Char = '\317'; }
    break;

  case 312:
#line 326 "lscp.y"
    { yyval.Char = '\320'; }
    break;

  case 313:
#line 327 "lscp.y"
    { yyval.Char = '\321'; }
    break;

  case 314:
#line 327 "lscp.y"
    { yyval.Char = '\322'; }
    break;

  case 315:
#line 327 "lscp.y"
    { yyval.Char = '\323'; }
    break;

  case 316:
#line 328 "lscp.y"
    { yyval.Char = '\324'; }
    break;

  case 317:
#line 328 "lscp.y"
    { yyval.Char = '\325'; }
    break;

  case 318:
#line 328 "lscp.y"
    { yyval.Char = '\326'; }
    break;

  case 319:
#line 329 "lscp.y"
    { yyval.Char = '\327'; }
    break;

  case 320:
#line 329 "lscp.y"
    { yyval.Char = '\330'; }
    break;

  case 321:
#line 329 "lscp.y"
    { yyval.Char = '\331'; }
    break;

  case 322:
#line 330 "lscp.y"
    { yyval.Char = '\332'; }
    break;

  case 323:
#line 330 "lscp.y"
    { yyval.Char = '\333'; }
    break;

  case 324:
#line 330 "lscp.y"
    { yyval.Char = '\334'; }
    break;

  case 325:
#line 331 "lscp.y"
    { yyval.Char = '\335'; }
    break;

  case 326:
#line 331 "lscp.y"
    { yyval.Char = '\336'; }
    break;

  case 327:
#line 331 "lscp.y"
    { yyval.Char = '\337'; }
    break;

  case 328:
#line 332 "lscp.y"
    { yyval.Char = '\340'; }
    break;

  case 329:
#line 332 "lscp.y"
    { yyval.Char = '\341'; }
    break;

  case 330:
#line 332 "lscp.y"
    { yyval.Char = '\342'; }
    break;

  case 331:
#line 333 "lscp.y"
    { yyval.Char = '\343'; }
    break;

  case 332:
#line 333 "lscp.y"
    { yyval.Char = '\344'; }
    break;

  case 333:
#line 333 "lscp.y"
    { yyval.Char = '\345'; }
    break;

  case 334:
#line 334 "lscp.y"
    { yyval.Char = '\346'; }
    break;

  case 335:
#line 334 "lscp.y"
    { yyval.Char = '\347'; }
    break;

  case 336:
#line 334 "lscp.y"
    { yyval.Char = '\350'; }
    break;

  case 337:
#line 335 "lscp.y"
    { yyval.Char = '\351'; }
    break;

  case 338:
#line 335 "lscp.y"
    { yyval.Char = '\352'; }
    break;

  case 339:
#line 335 "lscp.y"
    { yyval.Char = '\353'; }
    break;

  case 340:
#line 336 "lscp.y"
    { yyval.Char = '\354'; }
    break;

  case 341:
#line 336 "lscp.y"
    { yyval.Char = '\355'; }
    break;

  case 342:
#line 336 "lscp.y"
    { yyval.Char = '\356'; }
    break;

  case 343:
#line 337 "lscp.y"
    { yyval.Char = '\357'; }
    break;

  case 344:
#line 337 "lscp.y"
    { yyval.Char = '\360'; }
    break;

  case 345:
#line 337 "lscp.y"
    { yyval.Char = '\361'; }
    break;

  case 346:
#line 338 "lscp.y"
    { yyval.Char = '\362'; }
    break;

  case 347:
#line 338 "lscp.y"
    { yyval.Char = '\363'; }
    break;

  case 348:
#line 338 "lscp.y"
    { yyval.Char = '\364'; }
    break;

  case 349:
#line 339 "lscp.y"
    { yyval.Char = '\365'; }
    break;

  case 350:
#line 339 "lscp.y"
    { yyval.Char = '\366'; }
    break;

  case 351:
#line 339 "lscp.y"
    { yyval.Char = '\367'; }
    break;

  case 352:
#line 340 "lscp.y"
    { yyval.Char = '\370'; }
    break;

  case 353:
#line 340 "lscp.y"
    { yyval.Char = '\371'; }
    break;

  case 354:
#line 340 "lscp.y"
    { yyval.Char = '\372'; }
    break;

  case 355:
#line 341 "lscp.y"
    { yyval.Char = '\373'; }
    break;

  case 356:
#line 341 "lscp.y"
    { yyval.Char = '\374'; }
    break;

  case 357:
#line 341 "lscp.y"
    { yyval.Char = '\375'; }
    break;

  case 358:
#line 342 "lscp.y"
    { yyval.Char = '\376'; }
    break;

  case 359:
#line 342 "lscp.y"
    { yyval.Char = '\377'; }
    break;

  case 360:
#line 345 "lscp.y"
    { yyval.String = " ";      }
    break;

  case 362:
#line 347 "lscp.y"
    { yyval.String = yyvsp[-1].String + " "; }
    break;

  case 363:
#line 348 "lscp.y"
    { yyval.String = yyvsp[-1].String + yyvsp[0].String;  }
    break;

  case 364:
#line 351 "lscp.y"
    { yyval.String = yyvsp[-1].String; }
    break;

  case 365:
#line 352 "lscp.y"
    { yyval.String = yyvsp[-1].String; }
    break;


    }

/* Line 1010 of yacc.c.  */
#line 4264 "y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 514 "lscp.y"


/**
 * Will be called when an error occured (usually syntax error).
 */
void yyerror(const char* s) {
    dmsg(2,("LSCPParser: %s\n", s));
}

/**
 * Clears input buffer.
 */
void restart(yyparse_param_t* pparam, int& yychar) {
    bytes = 0;
    ptr   = 0;
}


